#include <stdlib.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <process.h>
#include <graphics.h>
#include <math.h>
#include <malloc.h>
#include <time.h>
#include <sys\timeb.h>
#include "touches.h"

#define MAX_PREM 5500L // Pas plus de 5500 (taille du heap)
#define BLACK 0
#define JAUNE 2
#define ORANGE 13
#define ROUGE 14
#define BLEU 5
#define GRIS_CLAIR 7
#define BLANC 15
#define GRIS_FONCE 12

//unsigned _stklen=32768;
// unsigned _heaplen=0;
// Avec ca en reserve, les fonctions peuvent tester jusqu'a 1153 au carre
int Premier[200]={
2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,
53,59,61,67,71,73,79,83,89,97,101,103,107,109,113,
127,131,137,139,149,151,157,163,167,173,179,181,191,193,197,
199,211,223,227,229,233,239,241,251,257,263,269,271,277,281,
283,293,307,311,313,317,331,337,347,349,353,359,367,373,379,
383,389,397,401,409,419,421,431,433,439,443,449,457,461,463,
467,479,487,491,499,503,509,521,523,541,547,557,563,569,571,
577,587,593,599,601,607,613,617,619,631,641,643,647,653,659,
661,673,677,683,691,701,709,719,727,733,739,743,751,757,761,
769,773,787,797,809,811,821,823,827,829,839,853,857,859,863,
877,881,883,887,907,911,919,929,937,941,947,953,967,971,977,
983,991,997,1009,1013,1019,1021,1031,1033,1039,1049,1051,1061,1063,1069,
1087,1091,1093,1097,1103,1109,1117,1123,1129,1151,1153};

// Variables graphiques
int Maxx=640;
int Maxy=480;
//int Maxx=1024;// Non !!!
//int Maxy=768;
int IsInitGraph=0;
struct palettetype Encre;

// Fonctions graphiques
long PortraitNbBse[15][4];
void DebGraph();
void FinGraph();
void ClrGraph();
void EffaceTexteXY(int pi_x, int pi_y, long pl_Lng);

// Fonctions d'initialisation
long ll_AleaLimInf;
long ll_AleaLong;
void Help();
void GetPortrait();
void SetPortrait();
void EnregistrePortrait(int pi_ctrl, int pi_touche, long pl_Nb, long pl_Base);
long gl_Palier3;
long gl_Palier2;
long gl_Palier1;

// Algorithme de Bresenham pour le tracage des lignes
long gl_org_x = 0;	// Coordonne X du point d'origine du trac de la droite
long gl_org_y = 0;	// Coordonne Y du point d'origine du trac de la droite
void bres_putpixel (long pl_x, long pl_y);	// Contient les regles de changement de couleur
void bres_moveto (long pl_x, long pl_y);	// Dplace le pointeur graphique
void bres_lineto (long pl_x1, long pl_y1);	// Trace une ligne de l'origine du pointeur au but
void bres_partlineto (long pl_x1, long pl_y1, double pdbl_part);	// Trace une ligne de l'origine du pointeur au but
void partlineto (long pl_x1, long pl_y1, double pdbl_part);
//void partmoveto (long pl_x1, long pl_y1);

// Fonctions de traitement des premiers et des bases
int  *Nb_PeriodeEntiere;	// La priode complte (tableau de [MAX_PREM+50L])
int  *Nb_Periode;			// La priode (tableau de [MAX_PREM+50L])
long Nb_LongPeriode;		// La longueur de la priode
long of_getperiode (long pl_premier, long pl_base);// Mefiance avec les non-premiers
long of_getinverse (long pl_premier, long pl_base);
long of_getgraine (long pl_premier);
long of_getpgcd (long pl_a, long pl_b);
long of_getPuissance (long pl_premier,long pl_Graine,long pl_Base);
long of_getNbBase (long pl_premier);
long of_getpremdiv (long pl_candidat);
static char *of_getdiv (long pl_candidat);
long of_getpremproche (long pl_candidat, long pl_inc);
long of_getperiodeNb (long pl_nombre, long pl_base, long pl_Dividende);
long of_getprembaseproche (long pl_premier, long pl_basecandidat, long pl_inc);
long of_getprempetitebaseproche (long pl_premier, long pl_basecandidat, long pl_inc);
long of_gettotalperiode(long pl_premier, long pl_base);

//long gl_Deja[MAX_PREM+50L];	// Lignes deja affichee
long *gl_Deja;	// Lignes deja affichee (tableau de [MAX_PREM+50L])
long gl_NbDeja;
long gl_CompteurPeriode;
int  AffichePremBase(long pl_Prem,long pl_Base);
//long GraphePremBaseDiv(long pl_Prem,long pl_Base, long pl_Dividende);
void GraphePremBase(long pl_Prem,long pl_Base);
long GraphePremBaseDivNb(long pl_Prem,long pl_Base, long pl_Dividende);
void AfficheRepartition(long &pl_Prem,long &pl_Base);
char NomFicPortrait[255];
void GetNbBaseEntree(long &pl_Nombre,long &pl_Base);

//==============================================================================================
void GetNbBaseEntree(long &pl_Nombre,long &pl_Base)
{

  static long ll_Nb,ll_Base;
//  int		touche;
  long		ll_i;
  long		ll_cpt;
  long		ll_MemNb;
  long		ll_MemBase;
  char		ls_temp[128];

	clearviewport();
	gotoxy(1,1);
	printf("Entrez un nombre entre 2 et %ld \nou <Entre> pour garder l'ancien (%ld):", long(MAX_PREM), pl_Nombre);
	ll_MemNb = pl_Nombre;
	gets(ls_temp);
	if (ls_temp[0]=='+' || ls_temp[0]=='-')
		{
		ll_Nb = atol(ls_temp+1);
		if (ll_Nb)
			if (ls_temp[0]=='+')
				ll_Nb = pl_Nombre + ll_Nb;
			else
				ll_Nb = pl_Nombre - ll_Nb;
		if (ll_Nb<0)
			ll_Nb = 0;
		}
	else
		{
		ll_Nb = atol(ls_temp);
		}

	if (!ll_Nb)
		{
		if (ls_temp[0]==0)
			printf("\nNombre = %ld", ll_MemNb);
		else
			printf("\nLe nombre '%s' sera remplac par : %ld", ls_temp, ll_MemNb);
		ll_Nb = ll_MemNb;
		if (ll_Nb>MAX_PREM)
			{
			ll_Nb=MAX_PREM;
			printf("\nLe nombre '%s' sera remplac par : %ld", ls_temp, ll_Nb);
			}
		}

	if (of_getpremdiv(ll_Nb)==ll_Nb) // C'est un premier
		{
		printf("\nPremier :%ld", ll_Nb);
		printf("\nListe de bases gnrant des priodes uniques: ");
	    ll_cpt = 0;
		for (ll_i = 2L;(ll_i <= ll_Nb - 1L) && (ll_cpt < 450L); ll_i++)
			{
			if (of_getperiode(ll_Nb, ll_i) == ll_Nb - 1L)
				{
				printf("%ld-", ll_i);
				ll_cpt++;
				}
			}
		}
	else
		{
		printf("\n%ld = %s", ll_Nb, of_getdiv (ll_Nb));
		}

	printf("\nEntrez une base entre 2 et %ld (ou <Entre> pour %ld):", ll_Nb-1, pl_Base);
	ll_MemBase = pl_Base;
	gets(ls_temp);
	if (ls_temp[0]=='+' || ls_temp[0]=='-')
		{
		ll_Base = atol(ls_temp+1);
		if (ll_Base)
			if (ls_temp[0]=='+')
				ll_Base = (pl_Base + ll_Base)%ll_Nb;
			else
				ll_Base = (ll_Nb + pl_Base - ll_Base)%ll_Nb;
		}
	else
		{
		ll_Base = atol(ls_temp);
		}

//	ll_Base = atol(ls_temp);
	if (!ll_Base)
		{
		if (ls_temp[0]==0)
			printf("\nBase = %ld", ll_MemBase);
		else
			printf("\nLa base '%s' sera remplace par : %ld", ls_temp, ll_MemBase%ll_Nb);
		ll_Base = ll_MemBase%ll_Nb;
		printf("\n<Entre> pour continuer");
		gets(ls_temp);
		}
	else
		{
		ll_Base = ll_Base%ll_Nb;
		if (ll_Base != ll_Base%ll_Nb)
			{
			printf("\nLa base %ld sera remplace par : %ld", ll_Base, ll_Base%ll_Nb);
			ll_Base = ll_Base%ll_Nb;
			printf("\n<Entre> pour continuer");
			gets(ls_temp);
			}
		}
pl_Nombre = ll_Nb;
pl_Base = ll_Base;

}

//==============================================================================================
/*
char NomFicVrac[15];
FILE *FichVrac;
long gl_CptVrac;
void GetAllFicVrac();
//void GetFicVrac(long &pl_Nombre, long &pl_Base);
void SetFicVrac(long pl_Nombre, long pl_Base);
*/
/*
//==============================================================================================
void SetFicVrac(long pl_Nombre, long pl_Base)
{
	if (FichVrac==NULL) return;

	if (gl_CptVrac>480L && gl_CptVrac<600L)
		printf("\aAttention, votre fichier %s va devenir ingrable\n", NomFicVrac);
	if (!(gl_CptVrac%2L) && gl_CptVrac<600L)
		{
		fprintf(FichVrac, "Touche F%ld\n", ((gl_CptVrac%24L)/2L)+1L);
		}
	if (gl_CptVrac<600L)
		{
		fprintf(FichVrac, "%ld\n", pl_Nombre);
		fprintf(FichVrac, "%ld\n", pl_Base);
		printf("\a");
		gl_CptVrac++;
		}
}

//==============================================================================================
void GetAllFicVrac()
{
	long	ll_Nb;
	long	ll_Ligne;
	int		touche;
	char	ls_temp[85];

	if (FichVrac==NULL) return;
	gl_CptVrac = 0L;
	ll_Ligne = 0L;

	do
		{
		if (!(gl_CptVrac%2L))	// "Touche Fx"
			{
			ll_Nb = atol(fgets(ls_temp, 80, FichVrac));
			ll_Ligne++;
			if (ll_Nb && !feof(FichVrac))
				printf("\a%s : ErreurLigne %ld:Touche F%ld\n", NomFicVrac, ll_Ligne, ((gl_CptVrac%24L)/2L)+1L);
//			if (ll_Nb && !feof(FichVrac))
//				{
//				ll_Ligne = ((gl_CptVrac/2L)*5L) + 1L;
//				printf("\a%s:ErreurLigne %ld:Touche F%ld\n", NomFicVrac, ll_Ligne, ((gl_CptVrac/2L)%24L)+1L);
//				}
			}
		ll_Nb = atol(fgets(ls_temp, 80, FichVrac));
		ll_Ligne++;
		if (!ll_Nb && !feof(FichVrac))
			printf("\a%s :%ld,ErreurNombre Ligne %ld:Touche F%ld\n", NomFicVrac, gl_CptVrac, ll_Ligne, (((gl_CptVrac%24L)/2L)+1L));
		if (!ll_Nb && !feof(FichVrac))
			{
			ll_Ligne = ((gl_CptVrac/2L)*5L) + (2*(gl_CptVrac%2L)) + 2L;
			printf("\a%s:ErreurNbLigne %ld:Touche F%ld\n", NomFicVrac, ll_Ligne, (((gl_CptVrac%24L)/2L)+1L));
			}
		ll_Nb = atol(fgets(ls_temp, 80, FichVrac));
		ll_Ligne++;
		if (!ll_Nb && !feof(FichVrac))
			printf("\a%s :%ld,ErreurBase Ligne %ld:Touche F%ld\n", NomFicVrac, gl_CptVrac, ll_Ligne, (((gl_CptVrac%24L)/2L)+1L));
		if (!ll_Nb && !feof(FichVrac))
			{
			ll_Ligne = ((gl_CptVrac/2L)*5L) + (2*(gl_CptVrac%2L)) + 3L;
			printf("\a%s:ErreurBseLigne %ld:Touche F%ld\n", NomFicVrac, ll_Ligne, (((gl_CptVrac%24L)/2L)+1L));
			}
		gl_CptVrac++;
		}
	while(!feof(FichVrac));

	gl_CptVrac--;

	fclose(FichVrac);

//	if (gl_CptVrac>0L)
//		{
//		printf("\a%s:%ld nombres enregistrs\n", NomFicVrac, gl_CptVrac);
//		while (!kbhit());
//		touche=getch();
//		if (!touche) touche=-getch();
//		}

	FichVrac = fopen(NomFicVrac,"a+");
//	gl_CptVrac = 0L;
}
*/
//==============================================================================================
/*
void GetFicVrac(long &pl_Nombre, long &pl_Base)
{
	long	ll_Nb;
	long	ll_Ligne;
	long	ll_feof;
	char	ls_temp[85];

	ll_feof = 0L;
	if (feof(FichVrac)) ll_feof = 1L;

	if (!(gl_CptVrac%2L) && !ll_feof)	// "Touche Fx"
		{
		ll_Nb = atol(fgets(ls_temp, 80, FichVrac));
		if (ll_Nb)
			{
			ll_Ligne = ((gl_CptVrac/4L)*5L) + 1L;
			printf("\a%s:ErreurLigne %ld:Touche F%ld\n", NomFicVrac, ll_Ligne, ((gl_CptVrac/2L)%24L)+1L);
			}
		}
	if (feof(FichVrac)) ll_feof = 1L;

	if (!ll_feof)
		{
		ll_Nb = atol(fgets(ls_temp, 80, FichVrac));
		if (!ll_Nb)
			{
			ll_Ligne = ((gl_CptVrac/4L)*5L) + (2*(gl_CptVrac%2L)) + 2L;
			printf("\a%s:ErreurNbLigne %ld:Touche F%ld\n", NomFicVrac, ll_Ligne, ((gl_CptVrac/2L)%24L)+1L);
			}
		else
			{
			pl_Nombre = ll_Nb;
			}
		}
	if (feof(FichVrac)) ll_feof = 1L;

	if (!ll_feof)
		{
		ll_Nb = atol(fgets(ls_temp, 80, FichVrac));
		if (!ll_Nb)
			{
			ll_Ligne = ((gl_CptVrac/4L)*5L) + (2*(gl_CptVrac%2L)) + 3L;
			printf("\a%s:ErreurBseLigne %ld:Touche F%ld\n", NomFicVrac, ll_Ligne, ((gl_CptVrac/2L)%24L)+1L);
			}
		else
			{
			pl_Base = ll_Nb;
			}
		}

	if (!feof(FichVrac))
		{
//		gl_CptVrac++;
		}
	else
		{
		fclose(FichVrac);
		FichVrac = fopen(NomFicVrac,"a+");
//		gl_CptVrac = 0L;
		printf("\a\a");
		}
}
*/
//==============================================================================================
void partlineto (long pl_x1, long pl_y1, double pdbl_part)
{
long	ll_x0;
long	ll_y0;
long	ll_x1;
long	ll_y1;

	ll_x0 = gl_org_x;
	ll_y0 = gl_org_y;
	ll_x1 = ll_x0 + ((pl_x1 - ll_x0)*pdbl_part);
	ll_y1 = ll_y0 + ((pl_y1 - ll_y0)*pdbl_part);
	lineto (ll_x1, ll_y1);
}

//==============================================================================================
void bres_partlineto (long pl_x1, long pl_y1, double pdbl_part)
{
long	ll_x0;
long	ll_y0;
long	ll_x1;
long	ll_y1;

	ll_x0 = gl_org_x;
	ll_y0 = gl_org_y;
	ll_x1 = ll_x0 + ((pl_x1 - ll_x0)*pdbl_part);
	ll_y1 = ll_y0 + ((pl_y1 - ll_y0)*pdbl_part);
	bres_lineto (ll_x1, ll_y1);
}

//==============================================================================================
void AfficheRepartition(long &pl_Nombre,long &pl_Base)
{
  char		ls_temp[128];
  int		touche;
  long  	ll_i;
  double	Ang;
  long  	ll_Diam;
  long  	ll_Per;
  long  	ll_Inv;
  long		ll_Mult;
  long		ll_Graine;
  long		ll_pgcd;
  double	ldbl_Abondance;
  long		ll_NbBase;
  long		ll_NbMult;
  long		ll_TabMult[30];
  long		ll_m;
  long		ll_trouvMult;
  long		ll_NbChange;		// Pour les touches '-','+',CFD et CFG si le nombre a chang
  long		ll_MemNb=pl_Nombre;	// Pour sortie avec ESC
  long		ll_MemBase=pl_Base;	// Pour sortie avec ESC
  long		ll_MemBasePourInv;	// Pour la touche 'i' si pas d'inverse
  long		ll_MemAffBase;		// Pour effacement du marquage
  long		ll_MemAffInv;		// Pour effacement du marquage
  long		ll_IncAlt;			// Incrment pour la touche Alt
  char		ls_eff[16];
  long		ll_TotPer;			// Somme des longueur des priodes
  double	ldbl_Part;			// Partie de la droite  tracer (ll_TotPer/(pl_Nombre-1))
  int		*li_PerUniq;
  int		li_Sym;
  int		li_ASym;
  int		li_hit;

//  printf("Taille mmoire disponible :%lu demande %ld", _memmax(), sizeof(int)*(MAX_PREM+50L));
//  while (!kbhit());
//  touche=getch();
//  if (!touche) touche=-getch();

  if ((li_PerUniq =  (int *) malloc(sizeof(int)*(MAX_PREM+50L))) == NULL)
		{
		clearviewport();
		printf("Erreur d'allocation mmoire pour li_PerUniq\n");
		exit(1);
		}

  ll_Diam=220;
  for (ll_i = 0L; ll_i < 16L; ll_i++)
	ls_eff[ll_i]=219;

  ls_eff[15]=0;

  ll_MemAffBase=0L;
  ll_MemAffInv=0L;


NouveauNombre:
     if (of_getpremdiv(pl_Nombre)==pl_Nombre)	// C'est un premier
		{
		clearviewport();
		//============================================
		// On affiche le premier, la base et l'inverse
		setcolor(JAUNE);
		sprintf(ls_temp, "Premier=%ld",pl_Nombre);
		outtextxy(1, 1 , ls_temp);
		setcolor(ORANGE);
		sprintf(ls_temp, "p-1=%s",of_getdiv (pl_Nombre-1));
		outtextxy((80 - strlen(ls_temp))*8, 1 + 14*31 , ls_temp);
		setcolor(JAUNE);
		sprintf(ls_temp, "Base   =%ld",pl_Base);
		outtextxy(1, 1+14*1 , ls_temp);
// MARQUAGE
		setcolor(BLANC);	// Marquage de la base
		Ang=M_PI*(((double)pl_Base*2.0)/(double)pl_Nombre);
		moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
		lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));

		ll_Inv = of_getinverse(pl_Nombre, pl_Base);
		if (ll_Inv>pl_Base)
			setcolor(ORANGE);
		else
			setcolor(GRIS_CLAIR);
		if (ll_Inv)
			{
			sprintf(ls_temp, "BaseInv=%ld",ll_Inv);
			outtextxy(1, 1+14*2 , ls_temp);
// MARQUAGE
			if (ll_Inv==pl_Base)
				setcolor(BLEU);
			else
				setcolor(JAUNE);
			Ang=M_PI*(((double)ll_Inv*2.0)/(double)pl_Nombre);
			moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
			lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
			}

		ll_Per=of_getperiode(pl_Nombre, pl_Base);
		if ((pl_Nombre-1)==ll_Per)
			{
			setcolor(ROUGE);
			sprintf(ls_temp, "Priode unique");
			outtextxy(1, 1+14*3 , ls_temp);
			}

		//===========================
		// Puis les autres parametres
		setcolor(ROUGE);
		ll_Graine = of_getgraine(pl_Nombre);
		sprintf(ls_temp, "Graine = %ld",ll_Graine);
		outtextxy((80 - strlen(ls_temp))*8, 1 + 14*4 , ls_temp);
		ll_NbBase = of_getNbBase(pl_Nombre);
		sprintf(ls_temp, "Nb bases = %ld",ll_NbBase);
		outtextxy((80 - strlen(ls_temp))*8, 1 + 14*1 , ls_temp);
		ldbl_Abondance = ((double)(ll_NbBase))/((double)(pl_Nombre - 1L))*100.;
		sprintf(ls_temp, "Abondance=%10.7f\%",ldbl_Abondance);
		outtextxy((80 - strlen(ls_temp))*8, 1, ls_temp);
		setcolor(ORANGE);
		sprintf(ls_temp, "Abond.=%ld/%ld",ll_NbBase, pl_Nombre - 1L);
		outtextxy((80 - strlen(ls_temp))*8, 1 + 14*2, ls_temp);
		ll_pgcd = of_getpgcd (pl_Nombre - 1L, ll_NbBase);
		sprintf(ls_temp, "Abond.=%ld/%ld",(ll_NbBase/ll_pgcd), ((pl_Nombre - 1L)/ll_pgcd));
		outtextxy((80 - strlen(ls_temp))*8, 1 + 14*3, ls_temp);

		setcolor(GRIS_FONCE);
		sprintf(ls_temp, "Ph.Kolitcheff");
		outtextxy((80 - strlen(ls_temp))*8, 1 + 33*14, ls_temp);

		ll_NbMult = 0L;

//		ATTENTION !!!!
//		for (ll_i=2L;ll_i<pl_Nombre;ll_i++)
		li_hit=0;
		for (ll_i=1L;ll_i<pl_Nombre;ll_i++)
			{
			ll_Per=of_getperiode(pl_Nombre, ll_i);
			if ((pl_Nombre-1L)==ll_Per)	// Periode unique
				{
				li_PerUniq[ll_i]=1;
				// ===============================================
				// Trace la base sur le diametre si periode unique
				Ang=M_PI*(((double)ll_i*2.0)/(double)pl_Nombre);
				bres_moveto(319,240);
				bres_lineto(319+ll_Diam*sin(Ang),240-ll_Diam*cos(Ang));

//				bres_moveto(319,240);
//				bres_partlineto(319+ll_Diam*sin(Ang),240-ll_Diam*cos(Ang), 0.75);

				// ===============================================
				ll_Mult = (pl_Nombre - 1L)/ll_i;
				if (ll_Mult*ll_i==(pl_Nombre - 1L)) // ll_i est une base multiple de pl_Nombre
					{
					ll_Inv = of_getinverse(pl_Nombre, ll_i);
					if (ll_NbMult<20)
						{
						ll_trouvMult = 0;
						for (ll_m=0L;ll_m<ll_NbMult;ll_m++)
							{
							if (ll_TabMult[ll_m]==ll_i)
								ll_trouvMult = 1L;
							}

						if (!ll_trouvMult)
							{
							if (!ll_NbMult)
								{
								setcolor(BLANC);
								sprintf(ls_temp, "Multiples:");
								outtextxy(1, 1 + 14*6 , ls_temp);
								}
							ll_TabMult[ll_NbMult] = ll_i;
							ll_TabMult[ll_NbMult+1] = ll_Inv;
							if (ll_Inv>ll_i)
								setcolor(BLANC);
							else
								setcolor(ROUGE);
							sprintf(ls_temp, "%ld/%ld",ll_i, ll_Inv);
							outtextxy(1, 1 + 14*(7+(ll_NbMult/2)) , ls_temp);
							ll_NbMult+=2;
							}
						}
					else
						{
						sprintf(ls_temp, "Et d'autre...",ll_i, ll_Inv);
						outtextxy(1, 1 + 14*16, ls_temp);
						}

					// ======================
					// Marquage des multiples (dans tous les cas)
					moveto(319+(ll_Diam+19)*sin(Ang),240-(ll_Diam+19)*cos(Ang));
					if (ll_Inv>ll_i)
						setcolor(ORANGE);
					else
						setcolor(BLEU);
					lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));

					Ang=M_PI*(((double)ll_Inv*2.0)/(double)pl_Nombre);
					moveto(319+(ll_Diam+19)*sin(Ang),240-(ll_Diam+19)*cos(Ang));
					lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
					}
				// =========== Fin Mult ============================
				}
			else	// La priode n'est pas unique
				{
				li_PerUniq[ll_i]=0;
				}
			if (kbhit())
				{
				ll_i=pl_Nombre;
				li_hit=1;
				}
			}
		if (ll_NbMult)
			{
			setcolor(BLANC);
			if (ll_NbMult==2L)
				sprintf(ls_temp, "F1 => %ld", ll_TabMult[0]);
			else
				sprintf(ls_temp, "F1  F%ld => multiples", ll_NbMult/2);
			outtextxy(1, 1 + 14*32, ls_temp);
			}

		if (!li_hit)
			{
			li_Sym = 1;
			li_ASym = 1;
			for (ll_i=1L;ll_i<pl_Nombre;ll_i++)
				{
				if ((li_PerUniq[ll_i]==1) && (li_PerUniq[pl_Nombre - ll_i]==0))
					li_Sym = 0;

				if ((li_PerUniq[ll_i]==1) && (li_PerUniq[pl_Nombre - ll_i]==1))
					li_ASym = 0;
				}

			if (li_Sym == 1)
				{
				setcolor(BLANC);
				if ((pl_Nombre-1L)%4L)	// N'arrive jamais ?
					{
					setcolor(BLEU);
					printf("\a");
					}
				sprintf(ls_temp, "Symtrique");
				outtextxy((80 - strlen(ls_temp))*8, 1 + 14*5, ls_temp);
				}

			if (li_ASym == 1)
				{
				setcolor(BLANC);
				if (((pl_Nombre-1L)%4L)!=2)	// N'arrive jamais ?
					{
					setcolor(BLEU);
					printf("\a");
					}

				if (li_Sym == 1)	// N'arrive jamais (mais par scurit)
					{
					setcolor(ROUGE);
					printf("\a\a\a");
					sprintf(ls_temp, "AntiSym et Sym!");
					}
				else
					sprintf(ls_temp, "AntiSymtrique");
				outtextxy((80 - strlen(ls_temp))*8, 1 + 14*5, ls_temp);
				}

			if ((!li_ASym) && (!li_Sym))	// N'arrive jamais ?
				{
				setcolor(BLEU);
				printf("\a");
				sprintf(ls_temp, "ASymtrique");
				outtextxy((80 - strlen(ls_temp))*8, 1 + 14*6, ls_temp);
				}
			}	// Fin if (!li_hit)
MemePremier:
		setcolor(BLACK);
		outtextxy(1, 1+14*1 , ls_eff);
		outtextxy(1, 1+14*2 , ls_eff);
		outtextxy(1, 1+14*3 , ls_eff);
		outtextxy(1, 1+14*4 , ls_eff);
		// =======
		// La base
		setcolor(JAUNE);
		sprintf(ls_temp, "Base   =%ld",pl_Base);
		outtextxy(1, 1+14*1 , ls_temp);
// MARQUAGE
		setcolor(BLACK);	// Marquage de la base (effacement)
		Ang=M_PI*(((double)ll_MemAffBase*2.0)/(double)pl_Nombre);
		moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
		lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
		ll_MemAffBase = pl_Base;
		setcolor(BLANC);
		Ang=M_PI*(((double)pl_Base*2.0)/(double)pl_Nombre);
		moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
		lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));

		// =========
		// L'inverse
		ll_Inv = of_getinverse(pl_Nombre, pl_Base);
		if (ll_Inv>pl_Base)
			setcolor(ORANGE);
		else
			setcolor(GRIS_CLAIR);
		if (ll_Inv==pl_Base)
			setcolor(BLEU);
		sprintf(ls_temp, "BaseInv=%ld",ll_Inv);
		outtextxy(1, 1+14*2 , ls_temp);
// MARQUAGE
		setcolor(BLACK);	// Marquage de la base inverse (effacement)
		Ang=M_PI*(((double)ll_MemAffInv*2.0)/(double)pl_Nombre);
		moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
		lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
		ll_MemAffInv = ll_Inv;
		if (ll_Inv==pl_Base)
			setcolor(BLEU);
		else
			setcolor(JAUNE);
		Ang=M_PI*(((double)ll_Inv*2.0)/(double)pl_Nombre);
		moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
		lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));

		// ===============================
		// La periode unique si elle l'est
		if (pl_Base)
			{
			ll_Per=of_getperiode(pl_Nombre, pl_Base);
			if ((pl_Nombre-1)==ll_Per)
				{
				setcolor(ROUGE);
				sprintf(ls_temp, "Priode unique");
				outtextxy(1, 1+14*3 , ls_temp);
				setcolor(BLANC);	// Pour les multiples
				}
			else
				{
				setcolor(ROUGE);	// Pour les multiples
				}

			ll_Mult = (pl_Nombre - 1L)/pl_Base;
			if (ll_Mult*pl_Base==(pl_Nombre - 1L)) // ll_i est une base multiple de pl_Nombre
				{
				sprintf(ls_temp, "%ld*%ld=%ld", pl_Base, ll_Mult, pl_Nombre - 1L);
				outtextxy(1, 1 + 14*4 , ls_temp);
				}

			ll_Mult = (pl_Nombre - 1L)/ll_Inv;
			if (ll_Mult*ll_Inv==(pl_Nombre - 1L)) // ll_i est une base multiple de pl_Nombre
				{
				sprintf(ls_temp, "%ld*%ld=%ld", ll_Inv, ll_Mult, pl_Nombre - 1L);
				outtextxy(1, 1 + 14*4 , ls_temp);
				}
			}
		}
// ================================================================
// ================================================================
	else	// C'est pas un premier
		{
NouveauNonPremier:
		clearviewport();
		//============================================
		// On affiche le nombre, la base et l'inverse (s'il existe)

		setcolor(JAUNE);
		sprintf(ls_temp, "Nombre=%ld",pl_Nombre);
		outtextxy(1, 1 , ls_temp);

		setcolor(ORANGE);
		sprintf(ls_temp, "n=%s",of_getdiv (pl_Nombre));
		outtextxy(1, 1 + 14*1 , ls_temp);

		setcolor(JAUNE);
		sprintf(ls_temp, "Base=%ld",pl_Base);
		outtextxy(1, 1 + 14*2 , ls_temp);

		ll_Inv = of_getinverse(pl_Nombre, pl_Base);
		if (ll_Inv)	// S'il existe un inverse
			{
			setcolor(BLANC);	// En blanc la base
			Ang=M_PI*(((double)pl_Base*2.0)/(double)pl_Nombre);
			moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
			lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));

			if (ll_Inv>pl_Base)
				setcolor(ORANGE);
			else
				setcolor(GRIS_CLAIR);
			if (ll_Inv == pl_Base)
				setcolor(BLANC);
			sprintf(ls_temp, "BaseInv=%ld",ll_Inv);
			outtextxy(1, 1+14*3 , ls_temp);

			if (ll_Inv==pl_Base)
				setcolor(BLEU);
			else
				setcolor(JAUNE);
			Ang=M_PI*(((double)ll_Inv*2.0)/(double)pl_Nombre);
			moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
			lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
			}
		else
			{
			setcolor(ROUGE);	// En rouge la base
			Ang=M_PI*(((double)pl_Base*2.0)/(double)pl_Nombre);
			moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
			lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));

			setcolor(GRIS_CLAIR);
			sprintf(ls_temp, "Pas d'inverse");
			outtextxy(1, 1+14*3 , ls_temp);
			}

		ll_TotPer = of_gettotalperiode(pl_Nombre, pl_Base);
		setcolor(ORANGE);
		sprintf(ls_temp, "TotPer=%ld", ll_TotPer);
		outtextxy(1, 1+14*4 , ls_temp);

		// Affichage du thermomtre
		ldbl_Part = double(ll_TotPer)/double(pl_Nombre-1L);
		for (ll_i=1L;ll_i<4L;ll_i++)
			{
			setcolor(JAUNE);
			moveto(399,ll_i);
			lineto(640,ll_i);
			setcolor(BLEU);
			bres_moveto(399,ll_i);
			partlineto(640, ll_i, ldbl_Part);
			}

		setcolor(GRIS_FONCE);
		sprintf(ls_temp, "%c Svetan", 1);
		outtextxy((80 - strlen(ls_temp))*8, 1 + 32*14, ls_temp);

		setcolor(GRIS_FONCE);
		sprintf(ls_temp, "Ph.Kolitcheff");
		outtextxy((80 - strlen(ls_temp))*8, 1 + 33*14, ls_temp);

		setcolor(ORANGE);
		// Calcul a part plus rapidement:
		for (ll_i=1L;ll_i<pl_Nombre;ll_i++)
			{	// On affiche les bases gales  leur propre inverse
			if (ll_i == of_getinverse (pl_Nombre, ll_i))
				{
				Ang=M_PI*(((double)ll_i*2.0)/(double)pl_Nombre);
				moveto(319+(ll_Diam+19)*sin(Ang),240-(ll_Diam+19)*cos(Ang));
				lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
				}
			if (kbhit())
				ll_i=pl_Nombre;
			}

		// Deuxime boucle
		for (ll_i=1L;ll_i<pl_Nombre;ll_i++)
			{
			// ===============================================
			// Trace les bases et la longueur totale de leurs priodes
			ll_TotPer = of_gettotalperiode(pl_Nombre, ll_i);
			Ang=M_PI*(((double)ll_i*2.0)/(double)pl_Nombre);
			bres_moveto(319+ll_Diam*sin(Ang),240-ll_Diam*cos(Ang));
			ldbl_Part = double(ll_TotPer)/double(pl_Nombre-1L);
			bres_partlineto(319,240, ldbl_Part);
			if (kbhit())
				ll_i=pl_Nombre;
			}

MemeNonPremier:
		setcolor(BLACK);
		outtextxy(1, 1+14*2 , ls_eff);
		setcolor(JAUNE);
		sprintf(ls_temp, "Base=%ld",pl_Base);
		outtextxy(1, 1+14*2 , ls_temp);
		setcolor(BLACK);	// Marquage de la base (effacement)
		Ang=M_PI*(((double)ll_MemAffBase*2.0)/(double)pl_Nombre);
		moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
		lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
		ll_MemAffBase = pl_Base;

		setcolor(BLACK);
		outtextxy(1, 1+14*3 , ls_eff);
		ll_Inv = of_getinverse(pl_Nombre, pl_Base);
		if (ll_Inv)	// S'il existe un inverse
			{
			setcolor(BLANC);	// En blanc la base
			Ang=M_PI*(((double)pl_Base*2.0)/(double)pl_Nombre);
			moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
			lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));

			if (ll_Inv>pl_Base)
				setcolor(ORANGE);
			else
				setcolor(GRIS_CLAIR);
			if (ll_Inv == pl_Base)
				setcolor(BLANC);
			sprintf(ls_temp, "BaseInv=%ld",ll_Inv);
			outtextxy(1, 1+14*3 , ls_temp);

			setcolor(BLACK);	// Marquage de la base inverse (effacement)
			Ang=M_PI*(((double)ll_MemAffInv*2.0)/(double)pl_Nombre);
			moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
			lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
			ll_MemAffInv = ll_Inv;
			if (ll_Inv==pl_Base)
				setcolor(BLEU);
			else
				setcolor(JAUNE);
			Ang=M_PI*(((double)ll_Inv*2.0)/(double)pl_Nombre);
			moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
			lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
			}
		else
			{
			setcolor(ROUGE);	// En rouge la base
			Ang=M_PI*(((double)pl_Base*2.0)/(double)pl_Nombre);
			moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
			lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));

			setcolor(BLACK);	// Effacement de la base inverse
			Ang=M_PI*(((double)ll_MemAffInv*2.0)/(double)pl_Nombre);
			moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
			lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
			ll_MemAffInv = ll_Inv;
			setcolor(GRIS_CLAIR);
			sprintf(ls_temp, "Pas d'inverse");
			outtextxy(1, 1+14*3 , ls_temp);
			}

		ll_TotPer = of_gettotalperiode(pl_Nombre, pl_Base);

		setcolor(BLACK);
		outtextxy(1, 1+14*4 , ls_eff);
		setcolor(ORANGE);
		sprintf(ls_temp, "TotPer=%ld", ll_TotPer);
		outtextxy(1, 1+14*4 , ls_temp);

		// Affichage du thermomtre
		ldbl_Part = double(ll_TotPer)/double(pl_Nombre-1L);
		for (ll_i=1L;ll_i<4L;ll_i++)
			{
			setcolor(JAUNE);
			moveto(399,ll_i);
			lineto(640,ll_i);
			setcolor(BLEU);
			bres_moveto(399,ll_i);
			partlineto(640, ll_i, ldbl_Part);
			}
//		ldbl_Part = double(ll_TotPer)/double(pl_Nombre-1);
//		moveto(1,200);
//		lineto(1,480);

//		while (!kbhit());
//		touche=getch();
//		if (!touche) touche=-getch();


//		bres_moveto(1,200);
//		bres_partlineto(1, 480, ldbl_Part);
//		moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
//		lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
		}



/*
// ========================== SIGNATURE =================================
// =================
//  En bas a droite
// =================
//	setcolor(GRIS_CLAIR);
     if (of_getpremdiv(pl_Nombre)!=pl_Nombre)	// C'est un nombre compos
		{
		setcolor(GRIS_FONCE);
		sprintf(ls_temp, "%c Svetan", 1);
		outtextxy((80 - strlen(ls_temp))*8, 1 + 32*14, ls_temp);
		}

// =================
//  En bas a droite
// =================
	setcolor(GRIS_FONCE);
	sprintf(ls_temp, "Ph.Kolitcheff");
	outtextxy((80 - strlen(ls_temp))*8, 1 + 33*14, ls_temp);
*/
// ================================================
		// C'est un premier ou pas
		setcolor(ORANGE);
		sprintf(ls_temp, "Appuyez sur une touche");
		outtextxy(1, 1 + 33*14, ls_temp);
		while (!kbhit());
		touche=getch();
		if (!touche) touche=-getch();

		if ((touche<=F1 && touche>=F10) && (of_getpremdiv(pl_Nombre)==pl_Nombre))
			{
			if (abs(abs(F1)+touche) < ll_NbMult/2)
				pl_Base = ll_TabMult[abs(abs(F1)+touche)*2];
			}
		else
			{
			switch(touche)
				{
//					case 'P':
//						touche = 'p';
//					case 'p':
//						goto NouveauNombre;
/*
			case 'I':
				touche = 'i';
			case 'i':
				ll_MemBasePourInv = pl_Base;
				pl_Base = of_getinverse(pl_Nombre, pl_Base);

				if (pl_Base==0L)
					{
					clearviewport();
					setcolor(JAUNE);
					sprintf(ls_temp, "A I E  ! ! !");
					outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*5 , ls_temp);
					setcolor(BLANC);
					if (pl_Base%pl_Nombre)
						sprintf(ls_temp, "La base %ld n'admet pas d'inverse pour %ld", pl_Base, pl_Nombre);
					else
						sprintf(ls_temp, "La base %ld est multiple de %ld, elle n'admet pas d'inverse", pl_Base, pl_Nombre);
					outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*9 , ls_temp);
					pl_Base = ll_MemBase;
					while (!kbhit());
					touche=getch();
					if (!touche) touche=-getch();
					}
				if (of_getpremdiv(pl_Nombre)==pl_Nombre)	// C'est un premier
					goto MemePremier;
				else
					goto NouveauNonPremier;
*/
				case 'H':
					touche = 'h';
				case 'h':
					Help();
					goto NouveauNombre;

				case '-':
					ll_NbChange = pl_Nombre;
					pl_Base =  (pl_Base - 1L + pl_Nombre)%pl_Nombre;
					if (!pl_Base)
						if (pl_Nombre > 2L)
							{pl_Nombre--;printf("\a");}
					if (pl_Nombre == ll_NbChange)
						if (of_getpremdiv(pl_Nombre)==pl_Nombre)	// C'est un premier
							goto MemePremier;
						else
							goto MemeNonPremier;
					else
						goto NouveauNombre;

				case '+':
					ll_NbChange = pl_Nombre;
					pl_Base = (pl_Base + 1L)%pl_Nombre;
					if (!pl_Base)
						if (pl_Nombre<MAX_PREM)
							{pl_Nombre++;printf("\a");}
					if (pl_Nombre == ll_NbChange)
						if (of_getpremdiv(pl_Nombre)==pl_Nombre)	// C'est un premier
							goto MemePremier;
						else
							goto MemeNonPremier;
					else
						goto NouveauNombre;

				case AFH:
					pl_Nombre = of_getpremproche (pl_Nombre+1L, 1L);
//					pl_Base = of_getprempetitebaseproche(pl_Nombre, pl_Base, 1L);
					goto NouveauNombre;

				case AFB:
					pl_Nombre = of_getpremproche (pl_Nombre-1L, -1L);
//					pl_Base = of_getprempetitebaseproche(pl_Nombre, pl_Base, -1L);
					goto NouveauNombre;

				case AFD:
					ll_NbChange = pl_Nombre;
					pl_Nombre = of_getpremproche (pl_Nombre, 1L);
					pl_Base = of_getprembaseproche(pl_Nombre, pl_Base+1L, 1L);
					if (pl_Nombre == ll_NbChange)
						goto MemePremier;
					else
						goto NouveauNombre;

				case AFG:
					ll_NbChange = pl_Nombre;
					pl_Nombre = of_getpremproche (pl_Nombre, -1L);
					pl_Base = of_getprembaseproche(pl_Nombre, pl_Base-1L, -1L);
					if (pl_Nombre == ll_NbChange)
						goto MemePremier;
					else
						goto NouveauNombre;

				case CFD:
					ll_IncAlt = pl_Nombre/30L;
					if (ll_IncAlt<2)
						ll_IncAlt = 1L;
					else
						ll_IncAlt = of_getpremproche (ll_IncAlt, -1L);
					pl_Base = (pl_Base + ll_IncAlt)%pl_Nombre;
					if (of_getpremdiv(pl_Nombre)==pl_Nombre)	// C'est un premier
						goto MemePremier;
					else
						goto MemeNonPremier;	// Le nombre n'a pas chang

				case CFG:
					ll_IncAlt = pl_Nombre/30L;
					if (ll_IncAlt<2)
						ll_IncAlt = 1L;
					else
						ll_IncAlt = of_getpremproche (ll_IncAlt, -1L);
					pl_Base =  (pl_Base - ll_IncAlt + pl_Nombre)%pl_Nombre;
					if (of_getpremdiv(pl_Nombre)==pl_Nombre)	// C'est un premier
						goto MemePremier;
					else
						goto MemeNonPremier;	// Le nombre n'a pas chang

				case CFH:
					for (ll_i = 0L; ll_i<10L; ll_i++)
						pl_Nombre = of_getpremproche (pl_Nombre+1L, 1L);
					pl_Base = of_getprempetitebaseproche(pl_Nombre, pl_Base-1, -1L);
					goto NouveauNombre;

				case CFB:
					for (ll_i = 0L; ll_i<10L; ll_i++)
						pl_Nombre = of_getpremproche (pl_Nombre-1L, -1L);
					pl_Base = of_getprempetitebaseproche(pl_Nombre, pl_Base+1, 1L);
					goto NouveauNombre;

				case FH:
					if (pl_Nombre<MAX_PREM)
						pl_Nombre++;
					goto NouveauNombre;

				case FB:
					if (pl_Nombre > 2) pl_Nombre--;
					goto NouveauNombre;

				case FD:
					pl_Base = (pl_Base + 1L)%pl_Nombre;
					if (of_getpremdiv(pl_Nombre)==pl_Nombre)	// C'est un premier
						goto MemePremier;
					else
						goto MemeNonPremier;	// Le nombre n'a pas chang

				case FG:
					pl_Base =  (pl_Base - 1L + pl_Nombre)%pl_Nombre;
					if (of_getpremdiv(pl_Nombre)==pl_Nombre)	// C'est un premier
						goto MemePremier;
					else
						goto MemeNonPremier;	// Le nombre n'a pas chang

				case PGUP:
					for (ll_i = 0L; ll_i<50L; ll_i++)
						pl_Nombre = of_getpremproche (pl_Nombre+1L, 1L);
						pl_Base = of_getprempetitebaseproche(pl_Nombre, pl_Base-1, -1L);
					goto NouveauNombre;

				case PGDN:
					for (ll_i = 0L; ll_i<50L; ll_i++)
						pl_Nombre = of_getpremproche (pl_Nombre-1L, -1L);
					pl_Base = of_getprempetitebaseproche(pl_Nombre, pl_Base+1, 1L);
					goto NouveauNombre;

				case END:
					touche =ENTER;

				// On retourne avec les nouvelles valeurs de pl_Nombre et pl_Base
				case ENTER:
					break;

				// On retourne avec les anciennes valeurs de pl_Nombre et pl_Base
				case ESC:
					pl_Nombre = ll_MemNb;
					pl_Base = ll_MemBase;
					break;

				default:
					goto NouveauNombre;
				}	// Fin switch touche
			}	// Fin if (touche<=F1 && touche>=F10)
//		}	// Fin if premier

  free((void *)li_PerUniq);
}
//==============================================================================================
void main(int argc,char *argv[])
//void main()
{
  static long ll_Nb,ll_Base;
  int		touche;
  long		ll_i;
  long		ll_cpt;
  long		ll_MemNb;
  long		ll_MemBase;
  char		ls_temp[128];
  FILE		*FichInit;
  struct	timeb temps;
  long		ll_IncAlt;
  int		ib_SortieClav;
  time_t	temps_deb;
  time_t	temps_fin;
  int		li_CtrlE;

//  clrscr();
//  if (argc==2) {aLng=atoi(argv[1]);aBse=2L;}
//  if (argc==3) {aLng=atoi(argv[1]);aBse=atoi(argv[2]);}
  if (argc==1) {strcpy(NomFicPortrait, ".\\PORTRAIT.PHK");}
  if (argc==2) {strcpy(NomFicPortrait, argv[1]);}
//  if (argc<3) {strcpy(NomFicVrac, ".\\FRANKY.FRK");}
//  if (argc==3) {argv[1][12]=0;strcpy(NomFicVrac, argv[1]);}

  DebGraph();

//		printf("\nDebut vrac:\n%d\n'%s'\n'%s'\n", argc, NomFicVrac, NomFicPortrait);
//		gets(ls_temp);

// Ouverture du fichier vrac
//  FichVrac = fopen(NomFicVrac,"a+");
//  GetAllFicVrac();
//		printf("\nFin vrac");
//		gets(ls_temp);

	if ((Nb_PeriodeEntiere = (int *) malloc(sizeof(int)*(MAX_PREM+50L))) == NULL)
		{
		printf("Erreur d'allocation mmoire pour Nb_PeriodeEntiere\n");
		exit(1);
		}

	if ((Nb_Periode = (int *) malloc(sizeof(int)*(MAX_PREM+50L))) == NULL)
		{
		printf("Erreur d'allocation mmoire pour Nb_Periode\n");
		exit(1);
		}

	if ((gl_Deja =  (long *) malloc(sizeof(long)*(MAX_PREM+50L))) == NULL)
		{
		printf("Erreur d'allocation mmoire pour gl_Deja\n");
		exit(1);
		}


if ((FichInit = fopen("INIT.TXT","r")) != NULL)
	{
	ll_Nb = atol(fgets(ls_temp, 80, FichInit));
	ll_Nb = atol(fgets(ls_temp, 80, FichInit));
	ll_Base = atol(fgets(ls_temp, 80, FichInit));
	ll_Base = atol(fgets(ls_temp, 80, FichInit));
	ll_AleaLimInf = atol(fgets(ls_temp, 80, FichInit));
	ll_AleaLimInf = atol(fgets(ls_temp, 80, FichInit));
	if (ll_AleaLimInf < 2)
		{
		printf("\nErreur fichier INIT.TXT ligne 5:");
		printf("\nLa limite infrieure de l'alatoire, %ld sera remplace par 2", ll_AleaLimInf);
		ll_AleaLimInf = 2L;
		printf("\n<Entre> pour continuer");
		gets(ls_temp);
		}
	ll_AleaLong = atol(fgets(ls_temp, 80, FichInit));
	ll_AleaLong = atol(fgets(ls_temp, 80, FichInit));
	if ((ll_AleaLimInf + ll_AleaLong)> MAX_PREM)
		{
		printf("\nErreur fichier INIT.TXT ligne 6:");
		printf("\nLa longueur de l'alatoire, %ld sera remplace par %ld", ll_AleaLong, MAX_PREM - (ll_AleaLimInf));
		ll_AleaLong = MAX_PREM - (ll_AleaLimInf);
		printf("\n<Entre> pour continuer");
		gets(ls_temp);
		}

	gl_Palier1 = atol(fgets(ls_temp, 80, FichInit));
	gl_Palier1 = atol(fgets(ls_temp, 80, FichInit));
	if (!gl_Palier1)
		gl_Palier1 = 2500L;
	gl_Palier2 = atol(fgets(ls_temp, 80, FichInit));
	gl_Palier2 = atol(fgets(ls_temp, 80, FichInit));
	if (!gl_Palier2)
		gl_Palier2 = 3200L;
	gl_Palier3 = atol(fgets(ls_temp, 80, FichInit));
	gl_Palier3 = atol(fgets(ls_temp, 80, FichInit));
	if (!gl_Palier3)
		gl_Palier3 = 5000L;
	fclose(FichInit);
	}
else

	{
	ll_Nb=1013L;
	ll_Base=170L;
	ll_AleaLimInf = 150L;
	ll_AleaLong = 2350L;
	gl_Palier1 = 2500L;
	gl_Palier2 = 3200L;
	gl_Palier3 = 5000L;

	clearviewport();
	setcolor(JAUNE);
	sprintf(ls_temp, "B I E N V E N U E  ! ! !");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*5 , ls_temp);

	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Pour ce premier dmarrage, une info importante:");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*10 , ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "Pour obtenir de l'aide, appuyez sur la touche 'H' comme HELP");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*13 , ls_temp);

	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Vous obtiendrez alors  tout moment l'ecran qui va suivre");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*16 , ls_temp);

	setcolor(ORANGE);
	sprintf(ls_temp, "Appuyez sur une touche pour continuer");
	outtextxy(1, 1 + 33*14, ls_temp);
	while (!kbhit());
	touche=getch();
	if (!touche) touche=-getch();

	Help();
	}


//printf("\nDebut Portrait:\n%d\n'%s'\n'%s'\n", argc, NomFicVrac, NomFicPortrait);
//gets(ls_temp);
GetPortrait();
//printf("\nFin Portrait:\n%d\n'%s'\n'%s'\n", argc, NomFicVrac, NomFicPortrait);
//gets(ls_temp);

//AffichePremBase(ll_Nb,ll_Base);
GraphePremBase(ll_Nb,ll_Base);

do
	{
	if (kbhit())
		{
//////////////////////////////////////////
//		touche=getch();					//
//		if (!touche) touche=-getch();	//
//		clearviewport();				//
//		gotoxy(1, 1);					//
//		printf("touche %d   ", touche);	//
//////////////////////////////////////////
//		for (ll_i = 0L; ll_i<20L; ll_i++)
//			{
//			ftime(&temps);
//			srand(temps.millitm+rand());
//			printf("\n%d", rand());
//			}
//		while (!kbhit());
//////////////////////////////////////////

		li_CtrlE = 0;
		touche=getch();
		if (!touche) touche=-getch();
		switch(touche)
			{
//			case INS:
//				clearviewport();
//				SetFicVrac(ll_Nb, ll_Base);
//				GraphePremBase(ll_Nb,ll_Base);
//				break;


			case INS:
				clearviewport();
				PortraitNbBse[12][0] = ll_Nb;
				PortraitNbBse[12][1] = ll_Base;
				SetPortrait();
				GraphePremBase(ll_Nb,ll_Base);
				break;

//			case AINS:
//				clearviewport();
//				GetFicVrac(ll_Nb, ll_Base);
//				GraphePremBase(ll_Nb,ll_Base);
//				break;

			case 'P':
				touche = 'p';
			case 'p':
				touche = END;

			case 5:		// Ctrl E
				li_CtrlE = 1;
				touche = 'e';

			case 'E':
				touche = 'e';
			case 'e':
				ll_MemNb = ll_Nb;
				ll_MemBase = ll_Base;
				ib_SortieClav = 0;
				while (!ib_SortieClav)
					{
					ftime(&temps);
					srand(temps.millitm+rand());
					ll_Nb = ll_AleaLimInf + long((double(rand())/double(32768L))*double(ll_AleaLong));
					ll_Base = 2L+(long((double(rand())/double(32768L))*double(ll_Nb)))%(ll_Nb-2L);
					if (li_CtrlE == 1)
						{
						if ((ll_Nb%16L)!=8L)
							{
							while(((ll_Nb%16L)!=8L) && (ll_Nb<(MAX_PREM+16L)))
								ll_Nb++;
							if (rand()>=16384L)
								{
								ll_Base=(ll_Nb/4L)-1L;
								if (rand()>=16384L)
									{
									ll_Nb-=8L;
									ll_Base-=2L;
									}
								}

							else
								{
								ll_Base =((ll_Nb*3L)/4L)-1L;
								if (rand()>=16384L)
									{
									ll_Nb+=8L;
									ll_Base+=6L;
									}
								}
							}
						}

					GraphePremBase(ll_Nb,ll_Base);
					if (kbhit())
						ib_SortieClav = 1;
					else
						{
	  					temps_deb = time(&temps_deb);
	  					while (!ib_SortieClav && (difftime(temps_fin, temps_deb)<5))
	  						{
//							printf("%f", difftime(temps_fin, temps_deb));
		  					temps_fin = time(&temps_fin);
							if (kbhit())
								ib_SortieClav = 1;
							}
						}
					}




				if (ib_SortieClav)
					{
					touche=getch();
					if (!touche) touche=-getch();
					if (touche==ESC)
						{
						ll_Nb = ll_MemNb;
						ll_Base = ll_MemBase;
						}

					if (touche==INS)
						touche=ENTER;

//					if (touche==INS)
//						{
//						clearviewport();
//						SetFicVrac(ll_Nb, ll_Base);
//						GraphePremBase(ll_Nb,ll_Base);
//						}

					if (touche==ENTER)
						{
						clearviewport();
						PortraitNbBse[12][0] = ll_Nb;
						PortraitNbBse[12][1] = ll_Base;
						SetPortrait();
						GraphePremBase(ll_Nb,ll_Base);
						}
					}
				break;

			case END:
				AfficheRepartition(ll_Nb,ll_Base);// ATTENTION Passage par valeurs
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case 'A':
				touche = 'a';
			case 'a':
 				clearviewport();
				setcolor(BLANC);
				int	li_init=0;
				for (ll_i = li_init; ll_i < li_init + 256; ll_i++)
					{
					sprintf(ls_temp, "%3d %c", (int)ll_i, (int)ll_i);
					outtextxy(1+50*(ll_i/25), 14*(((ll_i - li_init)%25)+1) , ls_temp);
					}
				setcolor(ORANGE);
				sprintf(ls_temp, "Appuyez sur une touche pour continuer");
				outtextxy(1, 1 + 33*14, ls_temp);
				while (!kbhit());
				touche=getch();
				if (!touche) touche=-getch();
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case 'H':
				touche = 'h';
			case 'h':
				Help();
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case 'X':
				touche = 'x';
			case 'x':
				ftime(&temps);
				srand(temps.millitm+rand());
				ll_Nb = ll_AleaLimInf + long((double(rand())/double(32768L))*double(ll_AleaLong));
				ll_Base = 2L+(long((double(rand())/double(32768L))*double(ll_Nb)))%(ll_Nb-2L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case 'C':
				touche = 'c';
			case 'c':
				ftime(&temps);
				srand(temps.millitm+rand());
				ll_Nb = ll_AleaLimInf + long((double(rand())/double(32768L))*double(ll_AleaLong));
				ll_Nb = of_getpremproche (ll_Nb, 1L);
				ll_Base = 2L+(long((double(rand())/double(32768L))*double(ll_Nb)))%(ll_Nb-2L);
				ll_Base = of_getprempetitebaseproche(ll_Nb, ll_Base, 1L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case 'I':
				touche = 'i';
			case 'i':
				ll_MemBase = ll_Base;
				ll_Base = of_getinverse(ll_Nb, ll_Base);

				if (ll_Base==0L)
					{
					clearviewport();
					setcolor(JAUNE);
					sprintf(ls_temp, "A I E  ! ! !");
					outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*5 , ls_temp);
					setcolor(BLANC);
					if (ll_Base%ll_Nb)
						sprintf(ls_temp, "La base %ld n'admet pas d'inverse pour %ld", ll_Base, ll_Nb);
					else
						sprintf(ls_temp, "La base %ld est multiple de %ld, elle n'admet pas d'inverse", ll_Base, ll_Nb);
					outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*9 , ls_temp);
					ll_Base = ll_MemBase;
					while (!kbhit());
					touche=getch();
					if (!touche) touche=-getch();
					}

				GraphePremBase(ll_Nb,ll_Base);
				break;

			case 'V':
				touche = 'v';
			case 'v':
				ftime(&temps);
				srand(temps.millitm+rand());
				ll_Base = 2L+(long((double(rand())/double(32768L))*double(ll_Nb)))%(ll_Nb-2L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AFH:
				ll_Nb = of_getpremproche (ll_Nb+1L, 1L);
//				ll_Base = of_getprempetitebaseproche(ll_Nb, ll_Base, 1L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AFB:
				ll_Nb = of_getpremproche (ll_Nb-1L, -1L);
//				ll_Base = of_getprempetitebaseproche(ll_Nb, ll_Base, -1L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AFD:
				ll_Nb = of_getpremproche (ll_Nb, 1L);
//				ll_Base = of_getprempetitebaseproche(ll_Nb, ll_Base+1L, 1L);
				ll_Base = of_getprembaseproche(ll_Nb, ll_Base+1L, 1L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AFG:
				ll_Nb = of_getpremproche (ll_Nb, -1);
//				ll_Base = of_getprempetitebaseproche(ll_Nb, ll_Base-1L, -1L);
				ll_Base = of_getprembaseproche(ll_Nb, ll_Base-1L, -1L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CFH:
				for (ll_i = 0L; ll_i<10L; ll_i++)
					ll_Nb = of_getpremproche (ll_Nb+1L, 1L);
				ll_Base = of_getprempetitebaseproche(ll_Nb, ll_Base-1, -1L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CFB:
				for (ll_i = 0L; ll_i<10L; ll_i++)
					ll_Nb = of_getpremproche (ll_Nb-1L, -1L);
				ll_Base = of_getprempetitebaseproche(ll_Nb, ll_Base+1, 1L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CFD:
				ll_IncAlt = ll_Nb/30L;
				if (ll_IncAlt<2)
					ll_IncAlt = 1L;
				else
					ll_IncAlt = of_getpremproche (ll_IncAlt, -1L);
				ll_Base = (ll_Base + ll_IncAlt)%ll_Nb;
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CFG:
				ll_IncAlt = ll_Nb/30L;
				if (ll_IncAlt<2)
					ll_IncAlt = 1L;
				else
					ll_IncAlt = of_getpremproche (ll_IncAlt, -1L);
				ll_Base =  (ll_Base - ll_IncAlt + ll_Nb)%ll_Nb;
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case FH:
				if (ll_Nb<MAX_PREM)
					ll_Nb++;
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case FB:
				if (ll_Nb > 2) ll_Nb--;
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case FD:
				ll_Base = (ll_Base + 1L)%ll_Nb;
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case FG:
				ll_Base =  (ll_Base - 1L + ll_Nb)%ll_Nb;
				GraphePremBase(ll_Nb,ll_Base);
				break;




			case '.':
				GetNbBaseEntree(ll_Nb,ll_Base);	// Rferences
				GraphePremBase(ll_Nb,ll_Base);
				break;


			case '-':
				ll_Base =  (ll_Base - 1L + ll_Nb)%ll_Nb;
				if (!ll_Base)
					if (ll_Nb > 2L)
						{ll_Nb--;printf("\a");}
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case '+':
				ll_Base = (ll_Base + 1L)%ll_Nb;
				if (!ll_Base)
					if (ll_Nb<MAX_PREM)
						{ll_Nb++;printf("\a");}
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case ENTER:
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F1:
				ll_Nb = PortraitNbBse[1][0];
				ll_Base = PortraitNbBse[1][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF1:
				ll_Nb = PortraitNbBse[1][2];
				ll_Base = PortraitNbBse[1][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF1:
				EnregistrePortrait(0, 1, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF1:
				EnregistrePortrait(1, 1, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F2:
				ll_Nb = PortraitNbBse[2][0];
				ll_Base = PortraitNbBse[2][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF2:
				ll_Nb = PortraitNbBse[2][2];
				ll_Base = PortraitNbBse[2][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF2:
				EnregistrePortrait(0, 2, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF2:
				EnregistrePortrait(1, 2, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F3:
				ll_Nb = PortraitNbBse[3][0];
				ll_Base = PortraitNbBse[3][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF3:
				ll_Nb = PortraitNbBse[3][2];
				ll_Base = PortraitNbBse[3][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF3:
				EnregistrePortrait(0, 3, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF3:
				EnregistrePortrait(1, 3, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F4:
				ll_Nb = PortraitNbBse[4][0];
				ll_Base = PortraitNbBse[4][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF4:
				ll_Nb = PortraitNbBse[4][2];
				ll_Base = PortraitNbBse[4][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF4:
				EnregistrePortrait(0, 4, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF4:
				EnregistrePortrait(1, 4, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F5:
				ll_Nb = PortraitNbBse[5][0];
				ll_Base = PortraitNbBse[5][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF5:
				ll_Nb = PortraitNbBse[5][2];
				ll_Base = PortraitNbBse[5][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF5:
				EnregistrePortrait(0, 5, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF5:
				EnregistrePortrait(1, 5, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F6:
				ll_Nb = PortraitNbBse[6][0];
				ll_Base = PortraitNbBse[6][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF6:
				ll_Nb = PortraitNbBse[6][2];
				ll_Base = PortraitNbBse[6][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF6:
				EnregistrePortrait(0, 6, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF6:
				EnregistrePortrait(1, 6, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F7:
				ll_Nb = PortraitNbBse[7][0];
				ll_Base = PortraitNbBse[7][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF7:
				ll_Nb = PortraitNbBse[7][2];
				ll_Base = PortraitNbBse[7][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF7:
				EnregistrePortrait(0, 7, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF7:
				EnregistrePortrait(1, 7, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F8:
				ll_Nb = PortraitNbBse[8][0];
				ll_Base = PortraitNbBse[8][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF8:
				ll_Nb = PortraitNbBse[8][2];
				ll_Base = PortraitNbBse[8][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF8:
				EnregistrePortrait(0, 8, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF8:
				EnregistrePortrait(1, 8, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F9:
				ll_Nb = PortraitNbBse[9][0];
				ll_Base = PortraitNbBse[9][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF9:
				ll_Nb = PortraitNbBse[9][2];
				ll_Base = PortraitNbBse[9][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;


			case CF9:
				EnregistrePortrait(0, 9, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF9:
				EnregistrePortrait(1, 9, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F10:
				ll_Nb = PortraitNbBse[10][0];
				ll_Base = PortraitNbBse[10][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF10:
				ll_Nb = PortraitNbBse[10][2];
				ll_Base = PortraitNbBse[10][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF10:
				EnregistrePortrait(0, 10, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF10:
				EnregistrePortrait(1, 10, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F11:
				ll_Nb = PortraitNbBse[11][0];
				ll_Base = PortraitNbBse[11][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF11:
				ll_Nb = PortraitNbBse[11][2];
				ll_Base = PortraitNbBse[11][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF11:
				EnregistrePortrait(0, 11, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF11:
				EnregistrePortrait(1, 11, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F12:
				ll_Nb = PortraitNbBse[12][0];
				ll_Base = PortraitNbBse[12][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF12:
				ll_Nb = PortraitNbBse[12][2];
				ll_Base = PortraitNbBse[12][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF12:
				EnregistrePortrait(0, 12, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF12:
				EnregistrePortrait(1, 12, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;


//			case CPGUP:




			case CPGUP:
				if ((ll_Nb%16L)!=8L)
					{
					while(((ll_Nb%16L)!=8L) && (ll_Nb<(MAX_PREM+16L)))
						ll_Nb++;
					ll_Base=(ll_Nb/4L)-1L;
					}
				else
					{
					if (ll_Base==(ll_Nb/4L)-1L)
						ll_Base =((ll_Nb*3L)/4L)-1L;
					else
						{
						if ((ll_Nb<MAX_PREM))
							{
							ll_Nb++;
							while(((ll_Nb%16L)!=8L) && (ll_Nb<(MAX_PREM+16L)))
								ll_Nb++;
							ll_Base=(ll_Nb/4L)-1L;
							}
						else
							ll_Base =((ll_Nb*3L)/4L)-1L;		// 5
						}
					}
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CPGDN:
				if ((ll_Nb%16L)!=8L)
					{
					while(((ll_Nb%16L)!=8L) && (ll_Nb>8L))
						ll_Nb--;
					ll_Base =((ll_Nb*3L)/4L)-1L;		// 5
					}
				else
					{
					if (ll_Base==(((ll_Nb*3L)/4L)-1L))	// 5
						ll_Base =(ll_Nb/4L)-1L;			// 1
					else
						{
						if ((ll_Nb>8L))
							{
							ll_Nb--;
							while(((ll_Nb%16L)!=8L) && (ll_Nb>8L))
								ll_Nb--;
							ll_Base =((ll_Nb*3L)/4L)-1L;	// 5
							}
						else
							ll_Base = 1L;
						}
					}
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case PGUP:
				for (ll_i = 0L; ll_i<50L; ll_i++)
					ll_Nb = of_getpremproche (ll_Nb+1L, 1L);
				ll_Base = of_getprempetitebaseproche(ll_Nb, ll_Base-1, -1L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case PGDN:
				for (ll_i = 0L; ll_i<50L; ll_i++)
					ll_Nb = of_getpremproche (ll_Nb-1L, -1L);
				ll_Base = of_getprempetitebaseproche(ll_Nb, ll_Base+1, 1L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			}	//	Fin switch touche
 		}		//	Fin if kbhit()
	}
while(touche!=ESC);

free((void *)Nb_PeriodeEntiere);
free((void *)Nb_Periode);
free((void *)gl_Deja);

if ((FichInit = fopen("INIT.TXT","w+")) != NULL)
{
	fprintf(FichInit, "Au dmarrage on affiche le nombre:\n");
	fprintf(FichInit, "%ld\n",ll_Nb);
	fprintf(FichInit, "En base:\n");
	fprintf(FichInit, "%ld\n",ll_Base);
	fprintf(FichInit, "Dbut alatoire:\n");
	fprintf(FichInit, "%ld\n",ll_AleaLimInf);
	fprintf(FichInit, "Longueur alatoire:\n");
	fprintf(FichInit, "%ld\n",ll_AleaLong);
	fprintf(FichInit, "Couleurs :Palier1:\n");
	fprintf(FichInit, "%ld\n",gl_Palier1);
	fprintf(FichInit, "Couleurs :Palier2:\n");
	fprintf(FichInit, "%ld\n",gl_Palier2);
	fprintf(FichInit, "Couleurs :Palier3:\n");
	fprintf(FichInit, "%ld\n",gl_Palier3);
//	fprintf(FichInit, "Nom du fichier portrait:\n");
//	fprintf(FichInit, "PORTRAIT.TXT\n");
	fprintf(FichInit, "\n");
	fprintf(FichInit, "Si vous trafiquez ces lignes, gardez leurs leur place.\n");
	fprintf(FichInit, "Le nombre doit tre en ligne 2, la base en ligne 4 etc..\n");
	fprintf(FichInit, "Les lignes impaires sont ignores.\n");
	fclose(FichInit);
}

SetPortrait();

//fclose(FichVrac);

FinGraph();
return;
}

//=========================================================================================
//==============================================================================================
long of_getpremproche (long pl_candidat, long pl_inc)
{
static 	long  ll_Ret;

	if (pl_candidat<=2L && pl_inc<0L) return 2L;

	if (pl_candidat >= MAX_PREM && pl_inc>0L)
		{
		ll_Ret = pl_candidat;
		while ((of_getpremdiv(ll_Ret)!=ll_Ret) && (pl_candidat > MAX_PREM)) ll_Ret--;
		}
	else
		{
		ll_Ret = pl_candidat;
		while (of_getpremdiv(ll_Ret)!=ll_Ret) ll_Ret+=pl_inc;
		}

	return ll_Ret;
}


//==============================================================================================
long of_getprembaseproche (long pl_premier, long pl_basecandidat, long pl_inc)
{
	static long  ll_Ret;

	ll_Ret = pl_basecandidat%pl_premier;

	while (of_getperiode(pl_premier, ll_Ret)!=pl_premier-1L)
	{
	ll_Ret = (ll_Ret + pl_inc + pl_premier) % pl_premier;
	}
	return ll_Ret;
}

//==============================================================================================
long of_getprempetitebaseproche (long pl_premier, long pl_basecandidat, long pl_inc)
{
	static long	ll_Ret;
	int			li_Sortie;
	long		ll_Inverse;

	li_Sortie =0;
	ll_Ret = (pl_basecandidat+pl_premier)%pl_premier;

	while (!li_Sortie)
	{
	if (of_getperiode(pl_premier, ll_Ret)==(pl_premier-1L))
		{
		ll_Inverse = of_getinverse (pl_premier, ll_Ret);
		if (ll_Inverse >= ll_Ret)
			li_Sortie = 1;
		}
	if (!li_Sortie) ll_Ret = (ll_Ret + pl_inc + pl_premier) % pl_premier;
	}
	return ll_Ret;
}

//==============================================================================================
int  AffichePremBase(long pl_Prem,long pl_Base)
{
	char  ls_temp[128];
	long		ll_Inverse;

	clearviewport();
	setcolor(JAUNE);
	sprintf(ls_temp, "Prem=%ld",pl_Prem);
	outtextxy(1, 1 , ls_temp);
	sprintf(ls_temp, "Base=%ld",pl_Base);
	outtextxy(1,  1 + 14*1, ls_temp);

/*
	ll_Inverse = of_getinverse (pl_Prem, pl_Base);
	sprintf(ls_temp, "Inverse=%ld", ll_Inverse);
	outtextxy(1,  1 + 14*2, ls_temp);



	if (of_getperiodeNb(pl_Prem,pl_Base, 1L)==pl_Prem-1L)
		{
		sprintf(ls_temp, "Invariant");
		outtextxy(1,  1 + 14*3, ls_temp);
		}
*/

  return 1;
}

//======================================================================================
//======================================================================================
//======================================================================================
//======================================================================================
//==============================================================================================
void GraphePremBase(long pl_Prem,long pl_Base)
{
  long  ll_i;
  long  ll_j;
  int   touche;
  char  ls_temp[128];
  char  ls_eff[16];
  long	ll_Inverse;
  long  ll_puiss1;
  long  ll_puiss2;
  long  ll_Graine;
  long	ll_LngPer;
  long  ll_NbBase;
  double ldbl_Abondance;
  long  ll_pgcd;
  long  ll_Mult;
  long	ll_NoPal;

  long  ll_Diam;
  long  ll_Ecart;
  double Ang;
  long  ll_sin;
  long  ll_cos;
  long	ll_MemCpt;
  long	ll_CptLngPer;	// Somme en cours des periodes differentes
  long	ll_TotLngPer;	// Somme totale calcule des periodes differentes
  int	li_SortieTouche;
  long	ll_Per;
  double ldbl_Part;
  long	ll_bs1;
  long	ll_bs2;
  long	ll_swap;

li_SortieTouche = 0;

  short Pal[4][20]=
//          02,03,04,05,06,07,08,09,10,11,12,13,14,15,16


//		{{0,54, 9, 9, 9, 9, 7, 0, 0, 4, 4,24,52,36,63,62},
//		 {0,54,54, 9, 9, 9, 7, 0, 0, 4, 4,24,52,36,63,62},
//		 {0,54,54,54, 9, 9, 7, 7, 0, 0, 4,24,52,36,63,62},
//		 {0,54,54,54, 9, 9,36,36, 7, 0, 4,24,52,36,63,62}};

//		{{0,54, 9, 9, 9, 9, 7, 0, 0, 4, 4,24,52,36,63,62},
//		 {0,54,54, 9, 9, 9, 7, 0, 0, 4, 4,24,52,36,63,62},
//		 {0,54,54,54, 9, 9, 7, 7, 0, 0, 4,24,52,36,63,62},
//		 {0,54,54,54, 9, 9,36,36, 7, 0, 4,24,52,36,63,62}};
//		 {0,54,54,54, 9,36, 0, 9,36, 0, 4,24,52,36,63,62}};

// Original :                       Fin
		{{0,54, 9, 9, 9, 9, 7, 0, 0, 4, 4,24,52,36,63,62},
		 {0,54,54, 9, 9, 9, 7, 0, 0, 4, 4,24,52,36,63,62},
		 {0,54,54,54, 9, 9, 7, 7, 0, 0, 4,24,52,36,63,62},
		 {0,54, 0,54, 0, 9, 7,54, 9, 0,36,24,52,36,63,62}};
//		 {0,54, 0,54, 0, 9, 7,54, 9,36,36,24,52,36,63,62}};
//		 {0,54, 0,54, 0, 9, 7,54, 9, 0,36,24,52,36,63,62}};
	ll_Diam=220L;
	ll_Ecart=20L;

 clearviewport();

// if (pl_Prem < 5000L)
// 	ll_NoPal = 2L;
// if (pl_Prem < 3200L)
//	ll_NoPal = 1L;
// if (pl_Prem < 2500L)
//	ll_NoPal = 0L;

 ll_NoPal = 3L;
 if (pl_Prem < gl_Palier3)
 	ll_NoPal = 2L;
 if (pl_Prem < gl_Palier2)
	ll_NoPal = 1L;
 if (pl_Prem < gl_Palier1)
	ll_NoPal = 0L;

  for(ll_i=0L;ll_i<16L;ll_i++) Encre.colors[ll_i]=Pal[ll_NoPal][ll_i];
  setallpalette(&Encre);

  for (ll_i = 0L; ll_i < 16L; ll_i++)
	ls_eff[ll_i]=219;

  ls_eff[13]=0;

// ========================= Affichage =====================================================
// ========================= Affichage =====================================================
// ========================= Affichage =====================================================
// ========================= Affichage =====================================================
// ========================= Affichage =====================================================
// ========================= Affichage =====================================================
// =================
//  En haut a gauche la famille de bases
// =================
//  setcolor(ORANGE);
//  setcolor(BLEU);
  setcolor(JAUNE);
	if (pl_Base==0)
		{
		setcolor(BLANC);
		sprintf(ls_temp, "Base=%ldn", pl_Prem);
		}
	else
		{
		setcolor(JAUNE);
		sprintf(ls_temp, "Base=%ld+%ldn",pl_Base, pl_Prem);
		}
  outtextxy(1,  1 + 14*2, ls_temp);

// ================
//  En bas a gauche la decomposition de la base
// ================
if (pl_Base > 1)
	{
     if (of_getpremdiv(pl_Base)==pl_Base) // la base est un premier
	   sprintf(ls_temp, "%ld premier",pl_Base);
     else
 	   sprintf(ls_temp, "%ld=%s",pl_Base, of_getdiv (pl_Base));
   setcolor(ORANGE);
   outtextxy(1, 1 + 14*32 , ls_temp);
	}

// ================
//  Puis, on ecrit les "chiffres" de la periode infinie
// ================
	if (pl_Prem < 62)	// Si le nombre est assez petit
      {
		// et un zero !!!
	    setcolor(ROUGE);
	    outtextxy(316, 240-(ll_Diam+ll_Ecart), "0");

		for (ll_i = 1L; ll_i < pl_Prem; ll_i++)

			{
			Ang=M_PI*(((double)ll_i*2)/(double)pl_Prem);
		    setcolor(GRIS_CLAIR);
//		    sprintf(ls_temp, "%d",Nb_Periode[ll_i]);
		    sprintf(ls_temp, "%ld",ll_i);

			if (sin(Ang) >= 0.)
			   ll_sin = 310+(ll_Diam+ll_Ecart)*sin(Ang);
			else
			   ll_sin = 319+(ll_Diam+ll_Ecart)*sin(Ang);

	 	  	if (cos(Ang) >= 0.)
			   ll_cos = 240-(ll_Diam+ll_Ecart)*cos(Ang);
			else
			   ll_cos = 230-(ll_Diam+ll_Ecart)*cos(Ang);
			outtextxy(ll_sin,ll_cos, ls_temp);
			}
      }

// ========================== INVERSE =================================
// ==============================================================
// Il peut y avoir un inverse meme si le nombre n'est pas premier
  ll_Inverse = of_getinverse (pl_Prem, pl_Base);

// ===========================================
// On ecrit l'inverse de la base s'il y a lieu
  if (ll_Inverse)
  	{
// =================
//  En haut a gauche la base inverse
// =================

	if (pl_Base<ll_Inverse)
		setcolor(ORANGE);
	else
		if (pl_Base==ll_Inverse)
			setcolor(BLANC);
		else
			setcolor(GRIS_CLAIR);

	sprintf(ls_temp, "BInv=%ld+%ldn",ll_Inverse, pl_Prem);
	outtextxy(1,  1 + 14*3, ls_temp);

// ================
//  En bas a gauche la decomposition de la base inverse
// ================
	  if (of_getpremdiv(ll_Inverse)==ll_Inverse) // La base inverse est un premier
		sprintf(ls_temp, "%ld premier",ll_Inverse);
	  else
		sprintf(ls_temp, "%ld=%s",ll_Inverse, of_getdiv (ll_Inverse));
	setcolor(ORANGE);
	outtextxy(1, 1 + 33*14 , ls_temp);

	}

// ========================== PREMIER =================================
// ========================== PREMIER =================================
// ========================== PREMIER =================================
// =======================================================
  if (of_getpremdiv(pl_Prem)==pl_Prem) // C'est un premier
// =======================================================
  	{
// =================
//  En haut a gauche
// =================
	setcolor(JAUNE);
	// On l'ecrit en temps que premier
  	sprintf(ls_temp, "Prem=%ld",pl_Prem);
  	outtextxy(1, 1 , ls_temp);

	// Puis la decomposition de p-1
	setcolor(ORANGE);
  	sprintf(ls_temp, "p-1=%s",of_getdiv (pl_Prem-1));
	outtextxy(1, 1 + 14*1 , ls_temp);

// ========================== GRAINE PUISSANCES ======================
// ================
//  En bas a gauche
// ================
    setcolor(ROUGE);
	ll_Graine = of_getgraine (pl_Prem);
	sprintf(ls_temp, "Graine = %ld",ll_Graine);
	outtextxy(1, 1 + 14*29 , ls_temp);

	if (pl_Base)
		{
		ll_Per=of_getperiode(pl_Prem, pl_Base);
		setcolor(ORANGE);
		ll_puiss1 = of_getPuissance (pl_Prem,ll_Graine,pl_Base);
		ll_pgcd = of_getpgcd(pl_Prem-1, ll_puiss1);
		if ((ll_Per==pl_Prem-1L))	// Priode unique
			{
			setcolor(JAUNE);
			if (ll_pgcd!=1)			// Le PGCD doit tre gal  1
				{
				setcolor(BLEU);
				printf("\a\a");
				}
			}
		else
			{
			if (ll_pgcd==1)
				{
				setcolor(BLEU);
				printf("\a\a");
				}
			}
		sprintf(ls_temp, "%ld%c(%ld^%ld)%ld",pl_Base,240,ll_Graine,ll_puiss1,pl_Prem);
		outtextxy(1, 1 + 14*30 , ls_temp);

		setcolor(ORANGE);
		ll_puiss2 = of_getPuissance (pl_Prem,ll_Graine,ll_Inverse);
		ll_pgcd = of_getpgcd(pl_Prem-1, ll_puiss2);
		if ((ll_Per==pl_Prem-1L))	// Priode unique
			{
			setcolor(JAUNE);
			if (ll_pgcd!=1)			// Le PGCD doit tre gal  1
				{
				setcolor(BLEU);
				printf("\a\a");
				}
			}
		else
			{
			if (ll_pgcd==1)
				{
				setcolor(BLEU);
				printf("\a\a");
				}
			}
		sprintf(ls_temp, "%ld%c(%ld^%ld)%ld",ll_Inverse,240,ll_Graine,ll_puiss2,pl_Prem);
		outtextxy(1, 1 + 14*31 , ls_temp);

// ========================== MULTIPLES =================================
// =================
//  En bas a droite
// =================
		ll_bs1 = pl_Base;
		ll_bs2 = ll_Inverse;
		if (ll_bs2 < ll_bs1)	// On swappe les deux valeurs
			{
			ll_swap = ll_bs1;
			ll_bs1 = ll_bs2;
			ll_bs2 = ll_swap;
			}

		ll_Mult = (pl_Prem - 1)/ll_bs1;
		// La base est un multiple dans une priode unique
		if ((ll_Mult*ll_bs1==(pl_Prem - 1))	&& ((pl_Prem-1)==ll_Per))
			{
			setcolor(BLANC);
//			if ((ll_Mult%4)==1 || (ll_Mult%4)==2)
			if ((ll_Mult%4)==0 || (ll_Mult%4)==3)
				{
				setcolor(BLEU);
				printf("\a\a");
				}

			sprintf(ls_temp, "%ld*%ld=%ld",ll_bs1, ll_Mult, (pl_Prem - 1));
			outtextxy((80 - strlen(ls_temp))*8, 1 + 14*31, ls_temp);
			}

		ll_Mult=(pl_Prem - 1)/ll_bs2;
		// L'inverse (plus grand) est un multiple
		if ((ll_Mult*ll_bs2==(pl_Prem - 1))	&& ((pl_Prem-1)==ll_Per))
			{
			setcolor(BLEU);
			printf("\a\a");
			sprintf(ls_temp, "%%ld*%ld=%ld !",ll_bs2, ll_Mult, (pl_Prem - 1));
			outtextxy((80 - strlen(ls_temp))*8, 1 + 14*30, ls_temp);
			}
		}	// Fin	if (pl_Base) (PUISSANCES)



// ========================== ABONDANCE =================================
// =================
//  En haut a droite
// =================
	ll_NbBase = of_getNbBase (pl_Prem);
	setcolor(JAUNE);
	sprintf(ls_temp, "Nb bases = %ld",ll_NbBase);
	outtextxy((80 - strlen(ls_temp))*8, 1 + 14*1 , ls_temp);

    setcolor(ROUGE);
	ldbl_Abondance = ((double)(ll_NbBase))/((double)(pl_Prem - 1L))*100.;
	sprintf(ls_temp, "Abondance=%10.7f\%",ldbl_Abondance);
	outtextxy((80 - strlen(ls_temp))*8, 1, ls_temp);

	setcolor(ORANGE);
	sprintf(ls_temp, "Abond.=%ld/%ld",ll_NbBase, pl_Prem - 1L);
	outtextxy((80 - strlen(ls_temp))*8, 1 + 14*2, ls_temp);

	ll_pgcd = of_getpgcd (pl_Prem - 1L, ll_NbBase);
	sprintf(ls_temp, "Abond.=%ld/%ld",(ll_NbBase/ll_pgcd), ((pl_Prem - 1L)/ll_pgcd));
	outtextxy((80 - strlen(ls_temp))*8, 1 + 14*3, ls_temp);

// ========================== MULTIPLES =================================
// =================
//  En bas a droite
// =================
/*

	if (pl_Base)
		{
		ll_Per=of_getperiode(pl_Prem, pl_Base);
		ll_Mult=(pl_Prem - 1)/pl_Base;
		if (ll_Mult*pl_Base==(pl_Prem - 1))	// La base est un multiple
		   {
			if (pl_Base<=ll_Inverse)
			   setcolor(ORANGE);
			else
				{
			    setcolor(BLEU);	//	N'arrive jamais ?
				printf("\a\a\a");
				}

			sprintf(ls_temp, "Base %ld",pl_Base);
			outtextxy((80 - strlen(ls_temp))*8, 1 + 27*14, ls_temp);

			sprintf(ls_temp, "%ld divise %ld",pl_Base ,(pl_Prem - 1));
			outtextxy((80 - strlen(ls_temp))*8, 1 + 28*14, ls_temp);

			sprintf(ls_temp, "%ld*%ld = %ld",ll_Mult,pl_Base,(pl_Prem - 1));
			outtextxy((80 - strlen(ls_temp))*8, 1 + 29*14, ls_temp);

			if ((ll_Mult%4)==1 || (ll_Mult%4)==2)
				{
				setcolor(BLANC);
//				if ((pl_Prem-1)!=ll_Per)
				if ((pl_Prem-1)==ll_Per)
					{
					setcolor(BLEU);
					printf("\a\a\a");
					}
				sprintf(ls_temp, "%ld mod 4 = %ld",ll_Mult,(ll_Mult%4));
				}
			else
				{
				setcolor(ROUGE);
				if ((pl_Prem-1)==ll_Per)
					{
					setcolor(BLEU);
					printf("\a\a\a");
					}
				sprintf(ls_temp, "%ld mod 4 = %ld",ll_Mult,(ll_Mult%4));
				}
			outtextxy((80 - strlen(ls_temp))*8, 1 + 30*14, ls_temp);
		   }

		ll_Mult=(pl_Prem - 1)/ll_Inverse;
		if (ll_Mult*ll_Inverse==(pl_Prem - 1))	// L'inverse est un multiple
		   {
			if (pl_Base<ll_Inverse)
				{
			    setcolor(BLEU);	//	N'arrive jamais ?
				printf("\a\a\a");
				}
			else
			   setcolor(ORANGE);

		   sprintf(ls_temp, "Base %ld",ll_Inverse);
		   outtextxy((80 - strlen(ls_temp))*8, 1 + 27*14, ls_temp);

		   sprintf(ls_temp, "%ld divise %ld",ll_Inverse ,(pl_Prem - 1));
		   outtextxy((80 - strlen(ls_temp))*8, 1 + 28*14, ls_temp);

		   sprintf(ls_temp, "%ld*%ld = %ld",ll_Mult,ll_Inverse,(pl_Prem - 1));
		   outtextxy((80 - strlen(ls_temp))*8, 1 + 29*14, ls_temp);

			if ((ll_Mult%4)==1 || (ll_Mult%4)==2)
				{
				setcolor(BLANC);
//				if ((pl_Prem-1)!=ll_Per)
				if ((pl_Prem-1)==ll_Per)
					{
					setcolor(BLEU);
					printf("\a\a\a");
					}
				sprintf(ls_temp, "%ld mod 4 = %ld",ll_Mult,(ll_Mult%4));
				}
			else
				{
				setcolor(ROUGE);
				if ((pl_Prem-1)==ll_Per)
					{
					setcolor(BLEU);
					printf("\a\a\a");
					}
				sprintf(ls_temp, "%ld mod 4 = %ld",ll_Mult,(ll_Mult%4));
				}
		   outtextxy((80 - strlen(ls_temp))*8, 1 + 30*14, ls_temp);
		   }
		}
// ========================== MULTIPLES =================================
*/

	}
// ========================== NON PREMIER =================================
// ========================== NON PREMIER =================================
// ========================== NON PREMIER =================================
  else		// Le nombre est compose
  	{
// =================
//  En haut a gauche
// =================
	setcolor(JAUNE);
  	sprintf(ls_temp, "%ld=%s",pl_Prem, of_getdiv (pl_Prem));
  	outtextxy(1, 1, ls_temp);
    setcolor(ORANGE);
  	sprintf(ls_temp, "Non premier");
  	outtextxy(1, 1 + 1*14 , ls_temp);

// ========================== SIGNATURE =================================
// =================
//  En bas a droite
// =================
	setcolor(GRIS_FONCE);
	sprintf(ls_temp, "%c Svetan", 1);
	outtextxy((80 - strlen(ls_temp))*8, 1 + 32*14, ls_temp);
	}

// =================
//  En bas a droite
// =================
  setcolor(GRIS_FONCE);
  sprintf(ls_temp, "Ph.Kolitcheff");
  outtextxy((80 - strlen(ls_temp))*8, 1 + 33*14, ls_temp);

// ========================= Fin d'affichage ===============================================
// ========================= Fin d'affichage ===============================================
// ========================= Fin d'affichage ===============================================
// ========================= Fin d'affichage ===============================================
// ========================= Fin d'affichage ===============================================

//setcolor(BLANC);
//sprintf(ls_temp, "coucou !!!");
//outtextxy((80 - strlen(ls_temp))*8, 1 + 31*14, ls_temp);
//getch();


if (!pl_Base)
	{
	if (pl_Prem < 62L)
		putpixel(319, 20, 15);
	else
		putpixel(319, 1, 15);
	setcolor(BLANC);
	sprintf(ls_temp, "Fin");
	outtextxy(1, 1 + 14*17 , ls_temp);
	sprintf(ls_temp, "Toujours juste");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*3, ls_temp);
	return;
	}

gl_CompteurPeriode = 0;
gl_NbDeja = 0L;	// Nb lignes deja tracee

ll_MemCpt=0L;	// Si la periode a change
ll_CptLngPer=0L;// Somme des periodes differentes

ll_TotLngPer = of_gettotalperiode(pl_Prem, pl_Base);
if (ll_TotLngPer!=pl_Prem-1L)	// S'il n'est pas au maximum
	{
	ldbl_Part = double(ll_TotLngPer)/double(pl_Prem-1L);
	// Affichage du thermomtre
	for (ll_j=1L;ll_j<4L;ll_j++)
		{
		setcolor(JAUNE);
		moveto(399,ll_j);
		lineto(640,ll_j);
		setcolor(BLEU);
		bres_moveto(399,ll_j);
		partlineto(640, ll_j, ldbl_Part);
		}

	sprintf(ls_temp, "%ld/%ld", ll_TotLngPer, pl_Prem-1L);
	outtextxy((80 - strlen(ls_temp))*8, 1 + 14*1, ls_temp);

	ll_pgcd = of_getpgcd (pl_Prem - 1L, ll_TotLngPer);
	if (ll_pgcd!=1)
		{
		sprintf(ls_temp, "%ld/%ld",(ll_TotLngPer/ll_pgcd), ((pl_Prem - 1L)/ll_pgcd));
		outtextxy((80 - strlen(ls_temp))*8, 1 + 14*2, ls_temp);
		}
	}

//if (ll_TotLngPer && (of_getpremdiv(pl_Prem)!=pl_Prem)) // A deplacer....????
if (ll_TotLngPer) // A deplacer....????
	{
	setcolor(BLACK);
	outtextxy(1, 1 + 14*27 , ls_eff);	// Effacement
	outtextxy(1, 1 + 14*28 , ls_eff);	// Effacement
    setcolor(ORANGE);
	sprintf(ls_temp, "CptPer:0");
	outtextxy(1, 1 + 14*27, ls_temp);
	sprintf(ls_temp, "Fin  :%ld", ll_TotLngPer);
	outtextxy(1, 1 + 14*28, ls_temp);
	}

for (ll_i = 1L; ll_i < pl_Prem; ll_i++)
    {
		Nb_LongPeriode = of_getperiodeNb(pl_Prem, pl_Base, ll_i);

		if (Nb_LongPeriode==pl_Prem-1L)
			{
// =================
//  En haut a gauche
// =================
//			setcolor(JAUNE);
			// Effacement, puis ecriture de la longueur de la periode
//			setcolor(BLACK);
//			outtextxy(1, 1 + 14*5 , ls_eff);
	 	    setcolor(ORANGE);
			sprintf(ls_temp, "LngPer=%ld=p-1",Nb_LongPeriode);
			outtextxy(1, 1 + 14*5 , ls_temp);
			setcolor(ROUGE);
			sprintf(ls_temp, "Seule periode");
			outtextxy(1, 1 + 14*6 , ls_temp);
			setcolor(BLACK);
			outtextxy(1, 1 + 14*27 , ls_eff);	// Effacement
			outtextxy(1, 1 + 14*28 , ls_eff);	// Effacement
			}
		else
			{	// C'est pas une periode unique.
	// =================
	//  En haut a gauche
	// =================
			if (ll_TotLngPer)
				{
				setcolor(BLACK);
				outtextxy(1, 1 + 14*8 , ls_eff);
				outtextxy(1, 1 + 14*9 , ls_eff);

		 	    setcolor(ORANGE);
				sprintf(ls_temp, "Divid:%ld",ll_i);
				outtextxy(1, 1 + 14*8, ls_temp);
				sprintf(ls_temp, "LngPer:%ld", Nb_LongPeriode);
				outtextxy(1, 1 + 14*9, ls_temp);

//				setcolor(BLACK);
//				outtextxy(1, 1 + 14*27 , ls_eff);	// Effacement
//				outtextxy(1, 1 + 14*28 , ls_eff);	// Effacement
//			    setcolor(ORANGE);
//				sprintf(ls_temp, "CptPer:0");
//				outtextxy(1, 1 + 14*27, ls_temp);
//				sprintf(ls_temp, "Fin  :%ld", ll_TotLngPer);
//				outtextxy(1, 1 + 14*28, ls_temp);

				}

			if (ll_i==1L)
				{
			    setcolor(ORANGE);
				if (ll_TotLngPer)
					{
					sprintf(ls_temp, "NoPer:1");
					outtextxy(1, 1 + 14*5, ls_temp);
					sprintf(ls_temp, "LngPer:%ld",Nb_LongPeriode);
					outtextxy(1, 1 + 14*6 , ls_temp);
					}
				else
					{
					setcolor(BLANC);
					sprintf(ls_temp, "Toujours juste");
					outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*3, ls_temp);
					}

				}
			}

//============================================================
		ll_LngPer = GraphePremBaseDivNb(pl_Prem,pl_Base, ll_i);
		if (!ll_LngPer)
			{
//			ll_CptJuste++;
//			setcolor(BLACK);
//			outtextxy(1, 1 + 14*25 , ls_eff);	// Effacement
//		    setcolor(ORANGE);
//			sprintf(ls_temp, "CptJst:%ld", ll_CptJuste);
//			outtextxy(1, 1 + 14*25, ls_temp);
// ON SORT !!!!!
			ll_i = pl_Prem;

			}
//============================================================
	if (!(pl_Base%pl_Prem))	// La base divise le nombre on sort
		ll_i = pl_Prem;

	if (ll_LngPer == pl_Prem-1L)	// Periode unique, on sort
		{
		// Vrification des puissances :
		if (of_getpgcd(pl_Prem-1, ll_puiss1)!=1)	//	N'arrive jamais ?
			{
			setcolor(BLEU);
			sprintf(ls_temp, "%ld%c(%ld^%ld)%ld",pl_Base,240,ll_Graine,ll_puiss1,pl_Prem);
			printf("\a\a");
			outtextxy(1, 1 + 14*30 , ls_temp);
			}

		if (of_getpgcd(pl_Prem-1, ll_puiss2)!=1)	//	N'arrive jamais ?
			{
			setcolor(BLEU);
			sprintf(ls_temp, "%ld%c(%ld^%ld)%ld",ll_Inverse,240,ll_Graine,ll_puiss2,pl_Prem);
			printf("\a\a");
			outtextxy(1, 1 + 14*31 , ls_temp);
			}
		ll_i = pl_Prem;	// On sort
		}
	else
		{
		if (ll_MemCpt!=gl_CompteurPeriode)// Nouvelle periode
			{
//			ll_MemDividende = ll_i;
			ll_MemCpt=gl_CompteurPeriode;
			ll_CptLngPer+=Nb_LongPeriode;// Somme des periodes differentes
			setcolor(BLACK);
			outtextxy(1, 1 + 14*5 , ls_eff);	// Effacement
			outtextxy(1, 1 + 14*6 , ls_eff);
			outtextxy(1, 1 + 14*7 , ls_eff);
		    setcolor(ORANGE);
			sprintf(ls_temp, "NoPer:%ld",(gl_CompteurPeriode));
			outtextxy(1, 1 + 14*5, ls_temp);
			sprintf(ls_temp, "LngPer:%ld",Nb_LongPeriode);
			outtextxy(1, 1 + 14*6 , ls_temp);
//			sprintf(ls_temp, "DerDiv:%ld", ll_MemDividende);
			sprintf(ls_temp, "DerDiv:%ld", ll_i);
			outtextxy(1, 1 + 14*7, ls_temp);

			setcolor(BLACK);
			outtextxy(1, 1 + 14*27 , ls_eff);	// Effacement
		    setcolor(ORANGE);
			sprintf(ls_temp, "CptPer:%ld",ll_CptLngPer);
			outtextxy(1, 1 + 14*27, ls_temp);

			// CONDITION :
			// Critere fin de traitement, seulement si egal (il ne doit pas depasser)
			// Et seulement si premier !!! (on sort pour les autres si ll_LngPer est nul)
//			if (ll_CptLngPer==ll_TotLngPer && (of_getpremdiv(pl_Prem)==pl_Prem))
			if ((ll_CptLngPer==ll_TotLngPer) && (ll_CptLngPer==pl_Prem - 1))
				ll_i = pl_Prem;
			}
		}
//	if (gl_CompteurPeriode*Nb_LongPeriode>=(pl_Prem-1)) Non !!!!
//	if (gl_CompteurPeriode*Nb_LongPeriode>=2*(pl_Prem-1)) Non !!!!
//		ll_i = pl_Prem;

		if (kbhit())
			{
			li_SortieTouche = 1;
			ll_i = pl_Prem;
			}
/*
     if (kbhit())
     	{
		touche=getch();
		if (!touche) touche=-getch();
		if (touche=' ')
			{
			while(!kbhit());
			touche=getch();
			if (!touche) touche=-getch();
			if (touche!=' ')
				ll_i = pl_Prem;
			}
		else
			{
			ll_i = pl_Prem;
			}
		}
*/
    }		// Fin for

	if (ll_LngPer != pl_Prem-1L)	// Periode compose
		{
		if (ll_TotLngPer)
			{
			setcolor(BLACK);
			outtextxy(1, 1 + 14*5 , ls_eff);	// Effacement
		    setcolor(ORANGE);
			sprintf(ls_temp, "NbPer:%ld",gl_CompteurPeriode);
			outtextxy(1, 1 + 14*5, ls_temp);
//				if (ll_TotLngPer)
//					{
			if (ll_CptLngPer!=ll_TotLngPer && !li_SortieTouche)
				{
//			setcolor(BLACK);
//			outtextxy(1, 1 + 14*25 , ls_eff);	// Effacement
//				if (ll_CptLngPer==ll_TotLngPer)
//					{
//				    setcolor(BLANC);
//					sprintf(ls_temp, "%ld/%ld", ll_CritFin, ll_CptLngPer);
//					outtextxy(1, 1 + 14*24, ls_temp);
//					}
//				else
//					{
				    setcolor(BLEU);
					printf("\a\a");
					sprintf(ls_temp, "Aie:%ld/%ld", ll_TotLngPer, ll_CptLngPer);
					outtextxy(1, 1 + 14*24, ls_temp);
//					}
				}
			}

		}

	if (!li_SortieTouche)
		{
//		setcolor(BLANC);
		setcolor(ROUGE);
		sprintf(ls_temp, "Fin");
		outtextxy(1, 1 + 14*17 , ls_temp);
		}
}

//======================================================================================
//======================================================================================
//==============================================================================================
long GraphePremBaseDivNb(long pl_nombre,long pl_base, long pl_Dividende)
{
	long	ll_i;
	double	Ang;
	long	ll_Diam;
	long	ll_Diam2;
//	char	ls_temp[1024];

	int		li_Org;
	int		li_Fin;
	int		li_Swap;
	int		li_Dej;
	int		li_trouv;
	int		li_NouvPer;
	long	ll_Code;

	ll_Diam=220;
	ll_Diam2=239;

	Nb_LongPeriode = of_getperiodeNb(pl_nombre, pl_base, pl_Dividende);

	if (Nb_LongPeriode < 2L) // La periode est egale a 1 ou 0 (le resultat tombe juste)
		{
		if (Nb_LongPeriode)	// La periode est egale a 1
			{
			Ang=M_PI*(((double)Nb_Periode[0]*2.0)/(double)pl_nombre);
			gl_CompteurPeriode++;
			}
		else		// Le resultat tombe juste
			{
			Ang=0.;
			}

		if (pl_nombre < 62L)
			   putpixel(319+ll_Diam*sin(Ang),240-ll_Diam*cos(Ang), 15);
		   	else
			   putpixel(319+ll_Diam2*sin(Ang),240-ll_Diam2*cos(Ang), 15);

		return Nb_LongPeriode;
		}

//=====================
	li_NouvPer = 0;
	for (ll_i = 0L; ll_i <= Nb_LongPeriode; ll_i++)
		{
		Ang=M_PI*(((double)Nb_Periode[ll_i]*2.0)/(double)pl_nombre);
		if (ll_i == 0L)	// On commence  tracer
		   {
			if (pl_nombre < 62L)	// dplacement du curseur
				bres_moveto(319+ll_Diam*sin(Ang),240-ll_Diam*cos(Ang));
			else
				bres_moveto(319+ll_Diam2*sin(Ang),240-ll_Diam2*cos(Ang));

			// On commence par ce point l.
			li_Org=(int)Nb_Periode[ll_i];
			}
		else
			{
			// Et on trace jusqu' ce point ci (au cycle suivant).
			li_Fin = (int)Nb_Periode[ll_i];
			if (li_Fin>li_Org)	// On change les valeurs pour trouver
				{
				li_Swap = li_Fin;	// La plus petite pour ll_Fin
				li_Fin = li_Org;	// Ce codage assure une valeur unique
				li_Org = li_Swap;	// Quelque soit le sens de parcourt de la droite
				}

			// =============================================
			// Ce codage assure une valeur unique
			ll_Code = (long)li_Fin*8192L+(long)li_Org;
			// Quelque soit le sens de parcourt de la droite
			// =============================================

			// On cherche si cette droite a dj t trace
			li_trouv = 0;	// On a rien trouv
			for (li_Dej=0;li_Dej<gl_NbDeja;li_Dej++)
				{
				if (gl_Deja[li_Dej] == ll_Code)	// Droite dj trace
					{li_trouv = 1;li_Dej=gl_NbDeja;}// On positionne li_trouv et on sort
				}

			if (!li_trouv)	// Nouvelle droite (hum!)
				{
				gl_Deja[gl_NbDeja] = ll_Code;// On mmorise ses coordonnes (indpendante du sens)
				gl_NbDeja++;	// L'adresse de ces coordonnes est incrmente
				// Une seule nouvelle droite suffit pour dcrter une nouvelle priode:
				li_NouvPer = 1;
				if (pl_nombre < 62L)	// On trace
					bres_lineto(319+ll_Diam*sin(Ang),240-ll_Diam*cos(Ang));
				else
					bres_lineto(319+ll_Diam2*sin(Ang),240-ll_Diam2*cos(Ang));
				}
			else	// La droite est dj trace, on dplace le curseur
				{
//				===========================================================================
				// Booster, fin du calcul, si une droite est trace, toute la priode l'est
				ll_i = Nb_LongPeriode + 1;
//				===========================================================================
				if (pl_nombre < 62L)
					bres_moveto(319+ll_Diam*sin(Ang),240-ll_Diam*cos(Ang));
				else
					bres_moveto(319+ll_Diam2*sin(Ang),240-ll_Diam2*cos(Ang));
				}

			// On recommence par ce point l.
			li_Org = (int)Nb_Periode[ll_i];

			}	// Fin if (ll_i == 0L)

	    if (kbhit()) ll_i = Nb_LongPeriode + 1; // Frappe d'une touche, fin du calcul

		}	// Fin for

	if (li_NouvPer) gl_CompteurPeriode++;

return Nb_LongPeriode;
}

//==============================================================================================
//==============================================================================================
void ClrGraph()
 {
 setviewport(0,0,Maxx,Maxy,1); //G,H,D,B
 clearviewport();
 }

//==============================================================================================
void DebGraph()
{
  int i;
  int gdriver = DETECT,gmode,errorcode;
  short Pal[20]={0,54,54, 9, 36, 38, 7, 0, 0, 4, 4, 4,58, 7, 7,62};//Minum

  if (!IsInitGraph)
     {
     initgraph(&gdriver,&gmode,"");
     errorcode=graphresult();
     if (errorcode!=grOk)
	{
	printf("Erreur graphique : %s\n",grapherrormsg(errorcode));
	getch();
	exit(0);
	}
     Maxx=getmaxx();
     Maxy=getmaxy();
     Encre.size=MAXCOLORS;
     for(i=0;i<16;i++) Encre.colors[i]=Pal[i];
     setallpalette(&Encre);
     IsInitGraph=1;
     }
   return;
}

//==============================================================================================
void FinGraph()
{
  closegraph();
  return;
}

//==============================================================================================
void EffaceTexteXY(int pi_x, int pi_y, long pl_Lng)
{
	long ll_i;
	char ls_eff[128];

	for (ll_i = 0L; ll_i < pl_Lng; ll_i++)
		ls_eff[ll_i]=219;

	ls_eff[pl_Lng]=0;

	setcolor(BLACK);
	outtextxy(pi_x, pi_y, ls_eff);
}

//==============================================================================================
//==============================================================================================
void bres_moveto(long pl_x, long pl_y)
{
	gl_org_x = pl_x;
	gl_org_y = pl_y;
	moveto (pl_x, pl_y);
}

//==============================================================================================
void bres_putpixel(long pl_x, long pl_y)
{
	int	li_color;

//                 0,01,02,03,04,05,06,07,08,09,10,11,12,13,14,15
//	short Pal[20]={0,54, 9, 9, 9, 9, 0, 0, 0, 4, 4, 4,58, 7, 7,62};//Minum
//	int	li_col[16]={  2, 3, 4, 5, 6, 7, 8, 9,10,11,10,12,13,14,15,15}; // Sauvegarder
//	int	li_col[16]={  2, 3, 4, 5, 6, 7, 8, 9,10,11,10,11,12,13,14,15}; // Original
	int	li_col[16]={  2, 3, 4, 5, 6, 7, 8, 9,10, 0,10,11,12,13,14,15};

	li_color = getpixel(pl_x, pl_y);
	putpixel(pl_x, pl_y, li_col[li_color]);
}

//==============================================================================================
//void bres_line(long pl_x0, long pl_y0, long pl_x1, long pl_y1)
void bres_lineto(long pl_x1, long pl_y1)
{
long		bl_Steep;
long		ll_DeltaX;
long		ll_DeltaY;
long		Delta;
long		ll_StepX;
long		ll_StepY;
long		ll_Coord;
long		ll_temp;

//	Changement de syntaxe pour faciliter les choses
long	pl_x0;
long	pl_y0;
	pl_x0 = gl_org_x;
	pl_y0 = gl_org_y;

bl_Steep = 0L;
ll_DeltaX = abs(pl_x1 - pl_x0);
if ((pl_x1 - pl_x0) > 0)
 	ll_StepX = 1L;
else
 	ll_StepX = -1L;
ll_DeltaY = abs(pl_y1 - pl_y0);
if ((pl_y1 - pl_y0) > 0)
 	ll_StepY = 1L;
else
	ll_StepY = -1L;

if (ll_DeltaY > ll_DeltaX)
	{
	bl_Steep = 1L;
	ll_temp = pl_x0;		//  Swap pl_x0, pl_y0
	pl_x0 = pl_y0;
	pl_y0 = ll_temp;
	ll_temp = ll_DeltaX;	//  Swap ll_DeltaX, ll_DeltaY
	ll_DeltaX = ll_DeltaY;
	ll_DeltaY = ll_temp;
	ll_temp = ll_StepX;		//  Swap ll_StepX, ll_StepY
	ll_StepX = ll_StepY;
	ll_StepY = ll_temp;
	}

Delta = (ll_DeltaY * 2L) - ll_DeltaX;

//for (ll_Coord = 0;ll_Coord <= ll_DeltaX;ll_Coord++)
for (ll_Coord = 0L;ll_Coord < ll_DeltaX;ll_Coord++)
	{
	if (bl_Steep == 1L)
		bres_putpixel(pl_y0, pl_x0);
	else
		bres_putpixel(pl_x0, pl_y0);

//	while (Delta >= 0)
	while (Delta > 0)
		{
		pl_y0 = pl_y0 + ll_StepY;
		Delta = Delta - (ll_DeltaX * 2L);
		}
	pl_x0 = pl_x0 + ll_StepX;
	Delta = Delta + (ll_DeltaY * 2L);
	}

bres_putpixel(pl_x1, pl_y1);
gl_org_x = pl_x1;
gl_org_y = pl_y1;

}
//==============================================================================================
//==============================================================================================
long of_getinverse(long pl_premier, long pl_base)
{
long		ll_premier;
long		ll_base;
static long		ll_Result;
long		ll_Inverse;

// Les cas triviaux 0 et 1 sont limins.
ll_Result = pl_base%pl_premier;
if (ll_Result==0L || ll_Result==1L)
	return ll_Result;

// On commence le calcul,
ll_Result = 1L;
ll_premier = pl_premier;
ll_base = pl_base;
ll_Inverse = ll_base;

do
{
	ll_Result = ll_Result + 1L;	// A partir de 2
	ll_Inverse = (ll_Inverse + ll_base)%ll_premier;
}
while (ll_Inverse != 1L && ll_Result < pl_premier);	// Jusqu'au premier.

if (ll_Inverse == 1L)	// Si on a trouv un inverse
	return ll_Result;	// On renvoie la base
else
	return 0L;
}

//==============================================================================================
long of_getgraine(long pl_premier)
{

static long		ll_Base;
long		ll_Per;

ll_Base = 1L;

do
{
	ll_Base = ll_Base + 1L;		// On commence en base 2
	ll_Per = of_getperiode(pl_premier, ll_Base);
}
while (ll_Per != pl_premier - 1L);

return ll_Base;
}

//==============================================================================================
long of_getpgcd(long pl_a, long pl_b)
{
static long	ll_a;
long	ll_b;
long	ll_r;

ll_a = pl_a;
ll_b = pl_b;

/*
// Par securite
if (ll_a < ll_b)	// si b est plus grand que a, on change les deux valeurs.
    {
	ll_r = ll_a;
	ll_a = ll_b;
	ll_b = ll_r;
    }
*/

while (ll_b > 0L)
    {
	ll_r = ll_a%ll_b;
	ll_a = ll_b;
	ll_b = ll_r;
    };

return ll_a;
}
//==============================================================================================
long of_getPuissance(long pl_premier,long pl_Graine,long pl_Base)
{
static 	long   ll_Ret;
	long   ll_BaseTest;

    ll_Ret = 0;
    ll_BaseTest = 1L;
	do
	{
     ll_BaseTest = (ll_BaseTest * pl_Graine)%pl_premier;
     ll_Ret++;
	}
	while(ll_BaseTest!=pl_Base);
return ll_Ret;
}

//==============================================================================================
long of_getNbBase(long pl_premier)
{

   long  ll_i;
static    long  ll_Ret;

   ll_Ret=0L;
   pl_premier--;

   for (ll_i=1L;ll_i<pl_premier;ll_i++)
       {
        if (of_getpgcd (pl_premier, ll_i)==1L)
		   ll_Ret++;
	   }

return ll_Ret;
}

//==============================================================================================
long of_getpremdiv(long pl_candidat)
{
long  ll_Limite;
static long  ll_Ret;
long  ll_Cpt;
long  ll_Test;

ll_Limite = long(sqrt(pl_candidat)) + 1L;
ll_Cpt = 0L;
do
{
	ll_Test = Premier[ll_Cpt];
	ll_Cpt++;
	if (pl_candidat%ll_Test == 0L)	// Le nombre est compos, on renvoi son premier diviseur
		ll_Ret = ll_Test;
	else

	if (ll_Test > ll_Limite)		// Le nombre est premier, on renvoi le candidat
		ll_Ret = pl_candidat;
}
while ((pl_candidat%ll_Test != 0L) && (ll_Test <= ll_Limite));

return ll_Ret;
}

//==============================================================================================
char *of_getdiv(long pl_candidat)
{
long  ll_Diviseur;
long  ll_MemDiviseur;
long  ll_i;
long  ll_Reste;
long  ll_NbDiv;
long  ll_div[20];
long  ll_exp[20];
static char ls_ret[128];
char  ls_temp[16];

ll_NbDiv = 0L;

for (ll_i=0L;ll_i<20L;ll_i++)
    {
	ll_div[ll_i] = 0L;
	ll_exp[ll_i] = 0L;
	}

ll_Reste = pl_candidat;
ll_MemDiviseur = 0L;

do
{
	ll_Diviseur = of_getpremdiv(ll_Reste);
	if (ll_MemDiviseur != ll_Diviseur)
	    {
		ll_NbDiv++;
		ll_MemDiviseur = ll_Diviseur;
		ll_div[ll_NbDiv] = ll_Diviseur;
		ll_exp[ll_NbDiv] = 1L;
	    }
	else
	    {
		ll_div[ll_NbDiv] = ll_Diviseur;
		ll_exp[ll_NbDiv]+=1L;
	    }
	ll_Reste = ll_Reste / ll_Diviseur;
}
while (ll_Reste != 1L);

strcpy(ls_ret, "");

for (ll_i=1L;ll_i<=ll_NbDiv;ll_i++)
   {
	sprintf(ls_temp, "%d", ll_div[ll_i]);
	strcat(ls_ret, ls_temp);
	if (ll_exp[ll_i] != 1L)
	   {
	    sprintf(ls_temp, "^%d", ll_exp[ll_i]);
	    strcat(ls_ret, ls_temp);
	   }
	if (ll_i != ll_NbDiv)
	   {
	    sprintf(ls_temp, "x");
	    strcat(ls_ret, ls_temp);
	   }
   }

return ls_ret;
}

//==============================================================================================
long of_getperiode(long pl_premier, long pl_base)
{
static long		ll_Periode;
long		ll_Dividende;
long		ll_Quotient;
long		ll_Reste;
long		ll_PremReste;
long		ll_Ret;

ll_Periode = 0L;
ll_Dividende = 1L;
ll_Quotient = 0L;

ll_Ret = pl_base%pl_premier;

if (ll_Ret==0L)
	return 0L;

if (ll_Ret==1L)
	pl_base = pl_base + pl_premier;

do
{
	ll_Reste = ll_Dividende - ll_Quotient * pl_premier;
	ll_Dividende = ll_Reste * pl_base;
	ll_Quotient = long(ll_Dividende / pl_premier);
	if (ll_Periode == 0L)
	    ll_PremReste = ll_Reste;
	ll_Periode++;
}
while (ll_Periode == 1L || ll_Reste != ll_PremReste);

return --ll_Periode;
}

//==============================================================================================
long of_getperiodeNb(long pl_nombre, long pl_base, long pl_Dividende)
{
  long  ll_Dividende1;
  long  ll_Dividende2;
  long  ll_Quotient1;
  long  ll_Quotient2;
  long  ll_Reste1;
  long  ll_Reste2;
  long  ll_base1;
  long  ll_base2;
  long  ll_i;
  long  ll_DebFin;

ll_base1 = pl_base%pl_nombre;
if (ll_base1==1) ll_base1 = 1 + pl_nombre;
ll_base2 = ll_base1 + pl_nombre;

ll_Dividende1	= pl_Dividende;
ll_Quotient1	= 0;
ll_Dividende2	= pl_Dividende;
ll_Quotient2	= 0;

for (ll_i = 0L; ll_i < pl_nombre; ll_i++)
	{
	ll_Reste1 = ll_Dividende1 - ll_Quotient1 * pl_nombre;
	ll_Dividende1 = ll_Reste1 * ll_base1;
	ll_Quotient1 = long(ll_Dividende1 / pl_nombre);

	ll_Reste2 = ll_Dividende2 - ll_Quotient2 * pl_nombre;
	ll_Dividende2 = ll_Reste2 * ll_base2;
	ll_Quotient2 = long(ll_Dividende2 / pl_nombre);

	Nb_PeriodeEntiere[ll_i] = (int)(ll_Quotient2 - ll_Quotient1);
	}


Nb_LongPeriode = 0L;
ll_i = pl_nombre - 1;
ll_DebFin  = (long)Nb_PeriodeEntiere[ll_i];
do
{
	ll_i--;
	Nb_LongPeriode++;
}
while(ll_DebFin != (long)Nb_PeriodeEntiere[ll_i]);

for (ll_i = 0L; ll_i <= (long)Nb_LongPeriode; ll_i++)
	Nb_Periode[ll_i] = Nb_PeriodeEntiere[pl_nombre - Nb_LongPeriode + ll_i - 1];

if (Nb_LongPeriode==1 && Nb_PeriodeEntiere[pl_nombre - 1]==0)
	Nb_LongPeriode = 0;

return Nb_LongPeriode;
}

//==============================================================================================
long of_gettotalperiode(long pl_Nb, long pl_Base)
{
	static long	ll_Ret;
	long	ll_PGCD = 0L;

	ll_Ret = pl_Nb;
	while (ll_PGCD != 1L)
		{
		ll_PGCD = of_getpgcd(ll_Ret, pl_Base);
		ll_Ret = ll_Ret/ll_PGCD;
		};
	ll_Ret--;
	return ll_Ret;
}


//==============================================================================================
//==============================================================================================
void EnregistrePortrait(int pi_ctrl, int pi_touche, long pl_Nb, long pl_Base)
{
	char	ls_temp[1024];
	int		touche;

	clearviewport();

	setcolor(JAUNE);
	sprintf(ls_temp, "A T T E N T I O N");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*5 , ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "E N R E G I S T R E M E N T");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*7 , ls_temp);

//	setcolor(BLANC);
	sprintf(ls_temp, "Vous vous apprtez  enregistrer %ld en base %ld", pl_Nb, pl_Base);
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*13 , ls_temp);

	if (pi_ctrl==0)
		{
		setcolor(ORANGE);
		sprintf(ls_temp, "Vous venez d'appuyer sur <Ctrl>F%d", pi_touche);
		outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*9 , ls_temp);

		setcolor(BLANC);
		sprintf(ls_temp, "En l'associant avec la touche F%d", pi_touche);
		outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*15 , ls_temp);

		setcolor(JAUNE);
		sprintf(ls_temp, "Bient%ct sur F%d", 147, pi_touche);
		outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*23 , ls_temp);
		}
	else
		{
		setcolor(ORANGE);
		sprintf(ls_temp, "Vous venez d'appuyer sur <Alt>F%d", pi_touche);
		outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*9 , ls_temp);

		setcolor(BLANC);
		sprintf(ls_temp, "En l'associant avec la touche <Shift>F%d", pi_touche);
		outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*15 , ls_temp);

		setcolor(JAUNE);
		sprintf(ls_temp, "Bient%ct sur <Shift>F%d", 147, pi_touche);
		outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*23 , ls_temp);
		}

	setcolor(JAUNE);
	sprintf(ls_temp, "Dans votre galerie de portrait");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*17 , ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "Pour confirmer l'enregistrement, appuyez sur 'O' ou 'o' (comme oui)");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*20 , ls_temp);

	setcolor(ORANGE);
	sprintf(ls_temp, "(Toute autre touche sera considre comme une annulation)");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*21 , ls_temp);

//==============================================================
	sprintf(ls_temp, "Appuyez sur une touche (o) pour continuer");
	outtextxy(1, 1 + 33*14, ls_temp);

	while (!kbhit());
	touche=getch();
	if (!touche) touche=-getch();
	if (touche == 'o' || touche == 'O')
		{
		if (pi_ctrl==0)
			{
			PortraitNbBse[pi_touche][0] = pl_Nb;
			PortraitNbBse[pi_touche][1] = pl_Base;
			}
		else
			{
			PortraitNbBse[pi_touche][2] = pl_Nb;
			PortraitNbBse[pi_touche][3] = pl_Base;
			}
		SetPortrait();
		}
}

//==============================================================================================
void GetPortrait()
{
	FILE	*FichPort;
	char	ls_buffer[128];
	struct	timeb temps;
	int		touche;
	int		li_i;
	long	ll_1;
	long	ll_2;
	long	ll_3;
	long	ll_4;
	int		li_CptLig;

	li_CptLig = 0;

	if ((FichPort = fopen(NomFicPortrait,"r")) != NULL)
		{
		for (li_i=1L; li_i<13L; li_i++)
			{
			fgets(ls_buffer, 80, FichPort);
			li_CptLig++;



//			printf("%d - ", li_i);
//			getch();



//			setcolor(BLANC);
//			sprintf(ls_buffer, "C'est la touche F%d qui est concerne", ((li_CptLig - 1)/5)+1);
//			sprintf(ls_buffer, "C'est la touche F%d qui est concerne", (li_CptLig)%5);
//			outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*20 , ls_buffer);

//======================================================
			ll_1 = atol(fgets(ls_buffer, 80, FichPort));
			if (feof(FichPort)) ll_1 = 0L;
			li_CptLig++;
			if (ll_1 <2 || ll_1>MAX_PREM)
				{
				clearviewport();
				setcolor(JAUNE);
				sprintf(ls_buffer, "E R R E U R  ! ! !" );
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*5 , ls_buffer);

				setcolor(ORANGE);
				sprintf(ls_buffer, "Ligne %d", li_CptLig);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*7 , ls_buffer);

				sprintf(ls_buffer, "Le nombre %ld n'est pas dans la fourchette [2,%ld]", ll_1, long(MAX_PREM));
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*9 , ls_buffer);

				setcolor(JAUNE);
				sprintf(ls_buffer, "Revoyez votre fichier %s", NomFicPortrait);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*11 , ls_buffer);

				setcolor(BLANC);
				sprintf(ls_buffer, "C'est la touche F%d qui est concerne", ((li_CptLig - 1)/5)+1);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*13 , ls_buffer);
//			getch();

				setcolor(JAUNE);
				ftime(&temps);
				srand(temps.millitm);
				PortraitNbBse[li_i][0] = ll_AleaLimInf + long((double(rand())/double(32768L))*double(ll_AleaLong));
				sprintf(ls_buffer, "Un nombre alatoire sera choisi : %ld", PortraitNbBse[li_i][0]);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*15 , ls_buffer);

				setcolor(ORANGE);
				sprintf(ls_buffer, "A moins de sortir avec <Ctrl>C ou <Ctrl><Pause>", li_CptLig);
				outtextxy(1, 1 + 14*18 , ls_buffer);

				sprintf(ls_buffer, "Appuyez sur une touche pour continuer");
				outtextxy(1, 1 + 33*14, ls_buffer);
				while (!kbhit());
				touche=getch();
				if (!touche) touche=-getch();
				}
			else
				{
				PortraitNbBse[li_i][0] = ll_1;
				}

//======================================================
			ll_2 = atol(fgets(ls_buffer, 80, FichPort));
			if (feof(FichPort)) ll_2 = 0L;
			li_CptLig++;
			if (ll_2 <2 || ll_2>ll_1)
				{
				clearviewport();
				setcolor(JAUNE);
				sprintf(ls_buffer, "E R R E U R  ! ! !" );
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*5 , ls_buffer);

				setcolor(ORANGE);
				sprintf(ls_buffer, "Ligne %d", li_CptLig);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*7 , ls_buffer);

				sprintf(ls_buffer, "La base %ld n'est pas dans la fourchette [2,%ld]", ll_2, ll_1);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*9 , ls_buffer);

				setcolor(JAUNE);
				sprintf(ls_buffer, "Revoyez votre fichier %s", NomFicPortrait);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*11 , ls_buffer);

				setcolor(BLANC);
				sprintf(ls_buffer, "C'est la touche F%d qui est concerne", ((li_CptLig - 1)/5)+1);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*13 , ls_buffer);

//			getch();
				setcolor(JAUNE);
				ftime(&temps);
				srand(temps.millitm);
				if (PortraitNbBse[li_i][0]==2L)
					PortraitNbBse[li_i][1]=2L;
				else
					PortraitNbBse[li_i][1] = 2L+(long((double(rand())/double(32768L))*double(PortraitNbBse[li_i][0])))%(PortraitNbBse[li_i][0]-2L);
				sprintf(ls_buffer, "Une base alatoire sera choisie : %ld", PortraitNbBse[li_i][1]);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*15 , ls_buffer);

				setcolor(ORANGE);
				sprintf(ls_buffer, "A moins de sortir avec <Ctrl>C ou <Ctrl><Pause>");
				outtextxy(1, 1 + 14*18 , ls_buffer);

				sprintf(ls_buffer, "Appuyez sur une touche pour continuer");
				outtextxy(1, 1 + 33*14, ls_buffer);
				while (!kbhit());
				touche=getch();
				if (!touche) touche=-getch();
				}
			else
				{
				PortraitNbBse[li_i][1] = ll_2;
				}

//======================================================
			ll_3 = atol(fgets(ls_buffer, 80, FichPort));
			if (feof(FichPort)) ll_3 = 0L;
			li_CptLig++;
			if (ll_3 <2 || ll_3>MAX_PREM)
				{
				clearviewport();
				setcolor(JAUNE);
				sprintf(ls_buffer, "E R R E U R  ! ! !" );
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*5 , ls_buffer);

				setcolor(ORANGE);
				sprintf(ls_buffer, "Ligne %d", li_CptLig);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*7 , ls_buffer);

				sprintf(ls_buffer, "Le nombre %ld n'est pas dans la fourchette [2,%ld]", ll_3, long(MAX_PREM));
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*9 , ls_buffer);

				setcolor(JAUNE);
				sprintf(ls_buffer, "Revoyez votre fichier %s", NomFicPortrait);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*11 , ls_buffer);

				setcolor(BLANC);
				sprintf(ls_buffer, "C'est la touche <Shift>F%d qui est concerne", ((li_CptLig - 1)/5)+1);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*13 , ls_buffer);

//			getch();
				setcolor(JAUNE);
				ftime(&temps);
				srand(temps.millitm);
				PortraitNbBse[li_i][2] = ll_AleaLimInf + long((double(rand())/double(32768L))*double(ll_AleaLong));
				sprintf(ls_buffer, "Un nombre alatoire sera choisi : %ld", PortraitNbBse[li_i][2]);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*15 , ls_buffer);

				setcolor(ORANGE);
				sprintf(ls_buffer, "A moins de sortir avec <Ctrl>C ou <Ctrl><Pause>");
				outtextxy(1, 1 + 14*18 , ls_buffer);

				sprintf(ls_buffer, "Appuyez sur une touche pour continuer");
				outtextxy(1, 1 + 33*14, ls_buffer);
				while (!kbhit());
				touche=getch();
				if (!touche) touche=-getch();
				}
			else
				{
				PortraitNbBse[li_i][2] = ll_3;
				}

//======================================================
			ll_4 = atol(fgets(ls_buffer, 80, FichPort));
			if (feof(FichPort)) ll_4 = 0L;
			li_CptLig++;
			if (ll_4 <2 || ll_4>ll_3)
				{
				clearviewport();
				setcolor(JAUNE);
				sprintf(ls_buffer, "E R R E U R  ! ! !" );
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*5 , ls_buffer);

				setcolor(ORANGE);
				sprintf(ls_buffer, "Ligne %d", li_CptLig);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*7 , ls_buffer);

				sprintf(ls_buffer, "La base %ld n'est pas dans la fourchette [2,%ld]", ll_4, ll_3);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*9 , ls_buffer);

				setcolor(JAUNE);
				sprintf(ls_buffer, "Revoyez votre fichier %s", NomFicPortrait);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*11 , ls_buffer);

				setcolor(BLANC);
				sprintf(ls_buffer, "C'est la touche <Shift>F%d qui est concerne", ((li_CptLig - 1)/5)+1);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*13 , ls_buffer);

				setcolor(JAUNE);
				ftime(&temps);
				srand(temps.millitm);
				if (PortraitNbBse[li_i][2]==2L)
					PortraitNbBse[li_i][3]=2L;
				else
					PortraitNbBse[li_i][3] = 2L+(long((double(rand())/double(32768L))*double(PortraitNbBse[li_i][2])))%(PortraitNbBse[li_i][2]-2L);
				sprintf(ls_buffer, "Une base alatoire sera choisie : %ld", PortraitNbBse[li_i][3]);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*15 , ls_buffer);

				setcolor(ORANGE);
				sprintf(ls_buffer, "A moins de sortir avec <Ctrl>C ou <Ctrl><Pause>");
				outtextxy(1, 1 + 14*18 , ls_buffer);

				sprintf(ls_buffer, "Appuyez sur une touche pour continuer");
				outtextxy(1, 1 + 33*14, ls_buffer);
				while (!kbhit());
				touche=getch();
				if (!touche) touche=-getch();
				}
			else
				{
				PortraitNbBse[li_i][3] = ll_4;
				}
			}
		fclose(FichPort);
		}
	else
		{
		clearviewport();
		setcolor(JAUNE);
		sprintf(ls_buffer, "======= A T T E N T I O N =======");
		outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*5 , ls_buffer);

		sprintf(ls_buffer, "======= F I C H I E R   P O R T R A I T =======");
		outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*11 , ls_buffer);

		setcolor(ORANGE);
		sprintf(ls_buffer, "Le fichier %s n'existe pas, il sera cr", NomFicPortrait);
		outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*7 , ls_buffer);

		sprintf(ls_buffer, "Les nombres et bases seront initialiss  2.");
		outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*9 , ls_buffer);

		sprintf(ls_buffer, "A moins de sortir avec <Ctrl>C ou <Ctrl><Pause>");
		outtextxy(1, 1 + 14*18 , ls_buffer);

		sprintf(ls_buffer, "Appuyez sur une touche pour continuer");
		outtextxy(1, 1 + 33*14, ls_buffer);

		while (!kbhit());
		touche=getch();
		if (!touche) touche=-getch();

		for (li_i=1; li_i<13; li_i++)
			{
			PortraitNbBse[li_i][0] = 7L;
			PortraitNbBse[li_i][1] = 3L;
			PortraitNbBse[li_i][2] = 7L;
			PortraitNbBse[li_i][3] = 3L;
			}

		SetPortrait();
		}
	}

//==============================================================================================
void SetPortrait()
{
	FILE *FichPort;
	char	buffer[128];
	int li_i;

	if ((FichPort = fopen(NomFicPortrait,"w+")) != NULL)
	{
		for (li_i=1; li_i<13; li_i++)
			{
			fprintf(FichPort, "touche F%d\n", li_i);
			fprintf(FichPort, "%ld\n", PortraitNbBse[li_i][0]);
			fprintf(FichPort, "%ld\n", PortraitNbBse[li_i][1]);
			fprintf(FichPort, "%ld\n", PortraitNbBse[li_i][2]);
			fprintf(FichPort, "%ld\n", PortraitNbBse[li_i][3]);
			}
		fprintf(FichPort, "\n");
		fprintf(FichPort, "1 - Nombre pour la touche\n");
		fprintf(FichPort, "2 - Base pour la touche\n");
		fprintf(FichPort, "3 - Nombre pour <Shift> la touche\n");
		fprintf(FichPort, "4 - Base pour <Shift> la touche\n");
		fclose(FichPort);
	}
}

//==============================================================================================
void Help()
{
	char	ls_temp[1024];
	int		touche;

	clearviewport();

	setcolor(JAUNE);
	sprintf(ls_temp, "G E N E R A L");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 , ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "%c %c", 24, 25);
	outtextxy(1, 1 + 14*1 , ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Variation des nombres en continu");
	outtextxy(1 + 8*4, 1 + 14*1 , ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "%c %c", 27, 26);
	outtextxy(1, 1 + 14*2 , ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Variation des bases en continu");
	outtextxy(1 + 8*4, 1 + 14*2, ls_temp);


	setcolor(BLANC);
	sprintf(ls_temp, "<Ctrl> %c %c %c %c", 24, 25, 27, 26);
	outtextxy(1, 1 + 14*3 , ls_temp);
	setcolor(GRIS_CLAIR);
//	sprintf(ls_temp, "Variation des premiers et des bases dans les priodes uniques");
	sprintf(ls_temp, "Variation rapide des premiers et des bases");
	outtextxy(1 + 8*15, 1 + 14*3, ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "<Alt>  %c %c %c %c", 24, 25, 27, 26);
	outtextxy(1, 1 + 14*4 , ls_temp);
	setcolor(GRIS_CLAIR);
//	sprintf(ls_temp, "Variation rapide des premiers et des bases");
//	sprintf(ls_temp, "Variation des premiers et des bases dans les priodes uniques");
	sprintf(ls_temp, "Les nombres deviennent premiers, et les bases  priodes uniques.");
	outtextxy(1 + 8*15, 1 + 14*4, ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "<PgUp><PgDn>");
	outtextxy(1, 1 + 14*5, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Variation trs rapide des premiers");
	outtextxy(1 + 8*13, 1 + 14*5, ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "- +");
	outtextxy(1, 1 + 14*6, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Variation continue de la base, puis du nombre");
	outtextxy(1 + 8*4, 1 + 14*6, ls_temp);

	setcolor(JAUNE);
	sprintf(ls_temp, "N'hsitez pas  appuyer en continu sur les touches ci-dessus.");
	outtextxy(1, 1 + 14*7, ls_temp);

	setcolor(BLANC);
//	sprintf(ls_temp, "p ou P");
	sprintf(ls_temp, "<Fin>");
	outtextxy(1, 1 + 14*8, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Affichage du plan, sortie avec ESC ou <Enter>");
	outtextxy(1 + 8*6, 1 + 14*8, ls_temp);

	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Les touches ci-dessus permettent alors de situer la base par rapport au nombre");
	outtextxy(1, 1 + 14*9, ls_temp);

//=======================
//	sprintf(ls_temp, "");
//	outtextxy(1, 1 + 14*9, ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "<Enter>");
	outtextxy(1, 1 + 14*10, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Affiche le nombre et la base en cours");
	outtextxy(1 + 8*8, 1 + 14*10, ls_temp);

//=======================
//	sprintf(ls_temp, "");
//	outtextxy(1, 1 + 14*11, ls_temp);

//==============================================================
	setcolor(JAUNE);
	sprintf(ls_temp, "A L E A T O I R E");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*12, ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "x ou X");
	outtextxy(1, 1 + 14*13, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Affichage alatoire du nombre et de la base");
	outtextxy(1 + 8*7, 1 + 14*13, ls_temp);


	setcolor(BLANC);
	sprintf(ls_temp, "c ou C");
	outtextxy(1, 1 + 14*14, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "De mme avec une priode unique");
	outtextxy(1 + 8*7, 1 + 14*14, ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "v ou V");
	outtextxy(1, 1 + 14*15, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Affichage alatoire d'une base pour un nombre donn");
	outtextxy(1 + 8*7, 1 + 14*15, ls_temp);

	sprintf(ls_temp, "La variation alatoire du nombre admet comme paramtres ceux de INIT.TXT");
	outtextxy(1, 1 + 14*16, ls_temp);
	sprintf(ls_temp, "La base varie entre 2 et le premier moins un");
	outtextxy(1, 1 + 14*17, ls_temp);

////=======================
////	sprintf(ls_temp, "");
////	outtextxy(1, 1 + 14*18, ls_temp);
	setcolor(BLANC);
	sprintf(ls_temp, "e ou E");
	outtextxy(1, 1 + 14*18, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Economiseur d'ecran:ESC pour sortir, <Enter> pour garder nombre et base");
	outtextxy(1 + 8*7, 1 + 14*18, ls_temp);
//=======================
//	sprintf(ls_temp, "");
//	outtextxy(1, 1 + 14*19, ls_temp);

//==============================================================
	setcolor(JAUNE);
	sprintf(ls_temp, "E D I T I O N");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*20, ls_temp);

	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Le point dcimal");
	outtextxy(1, 1 + 14*21, ls_temp);
	setcolor(BLANC);
	sprintf(ls_temp, "[.]");
	outtextxy(1 + 8*17, 1 + 14*21, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "du pav numrique passe en mode dition");
	outtextxy(1 + 8*21, 1 + 14*21, ls_temp);

	sprintf(ls_temp, "On entre alors un nombre entre 2 et %ld,", long(MAX_PREM));
	outtextxy(1, 1 + 14*22, ls_temp);
	sprintf(ls_temp, "puis une base plus petite que le nombre");
	outtextxy(1, 1 + 14*23, ls_temp);
//	sprintf(ls_temp, "Les donnes erronnes seront impitoyablement tronques,");
//	outtextxy(1, 1 + 14*23, ls_temp);
	sprintf(ls_temp, "<Entre> est une touche valide (mmorisation nombre, base)");
	outtextxy(1, 1 + 14*24, ls_temp);

//=======================
//	sprintf(ls_temp, "");
//	outtextxy(1, 1 + 14*25, ls_temp);

//==============================================================
	setcolor(JAUNE);
	sprintf(ls_temp, "P O R T R A I T S");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*26, ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "F1  F12");
	outtextxy(1, 1 + 14*27, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "associs ");
	outtextxy(1 + 8*9, 1 + 14*27, ls_temp);
	setcolor(BLANC);
	sprintf(ls_temp, "<Shift>");
	outtextxy(1 + 8*20, 1 + 14*27, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "(Majuscule) sont une galerie de portraits");
	outtextxy(1 + 8*28, 1 + 14*27, ls_temp);
	setcolor(BLANC);
	sprintf(ls_temp, "<Ctrl>Fx ou <Alt>Fx");
	outtextxy(1, 1 + 14*28, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "sauvegardent respectivement Fx ou <Shift>Fx");
	outtextxy(1 + 8*20, 1 + 14*28, ls_temp);

//=======================
//	sprintf(ls_temp, "");
//	outtextxy(1, 1 + 14*29, ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "h ou H");
	outtextxy(1, 1 + 14*30, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "affiche cette page d'aide");
	outtextxy(1 + 8*7, 1 + 14*30, ls_temp);


	setcolor(BLANC);
	sprintf(ls_temp, "<Esc>");
	outtextxy(1, 1 + 14*31, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "sort du programme");
	outtextxy(1 + 8*6, 1 + 14*31, ls_temp);

//=======================
//	sprintf(ls_temp, "");
//	outtextxy(1, 1 + 14*32, ls_temp);

	sprintf(ls_temp, "Appuyez sur une touche pour continuer");
	outtextxy(1, 1 + 33*14, ls_temp);

//==============================================================
	while (!kbhit());
	touche=getch();
	if (!touche) touche=-getch();
}

//==============================================================================================
